﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;

namespace BANF.BANFContacts
{
    [ToolboxItemAttribute(false)]
    
    public class BANFContacts : WebPart
    {
        // Visual Studio might automatically update this path when you change the Visual Web Part project item.
        private const string _ascxPath = @"~/_CONTROLTEMPLATES/BANF/BANFContacts/BANFContactsUserControl.ascx";

        private IWebPartRow _wpRowProvider;
        private System.Data.DataRowView _tableData;

        Control control;

        protected override void CreateChildControls()
        {
            control = Page.LoadControl(_ascxPath);
            Controls.Add(control);
        }

        protected override void OnInit(EventArgs e)
        {
            EnsureChildControls();
            base.OnInit(e);
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            if (_wpRowProvider != null)
            {
                _wpRowProvider.GetRowData(new RowCallback(GetRowData));
                PropertyDescriptorCollection props = _wpRowProvider.Schema;
                int count = 0;
                string creator = String.Empty;
                string requisitioner = string.Empty;
                string pur_group = string.Empty;
                if (props != null && props.Count > 0 && _tableData != null)
                {
                    foreach (PropertyDescriptor prop in props)
                    {
                        switch (prop.Name)
                        {
                            case "CreatedBy":
                                creator = _tableData.Row[count].ToString();
                                break;
                            case "Requisitioner":
                                requisitioner = _tableData.Row[count].ToString();
                                break;
                            case "PurchasingGroup":
                                pur_group = _tableData.Row[count].ToString();
                                break;
                        }
                        count++;
                     }

                    ((BANFContactsUserControl)control).Display_Contacts(creator, requisitioner, pur_group);
                }
                
                
                
                
            }
        }

        private void GetRowData(object rowData)
        {
            if (rowData != null)
            {
                _tableData = (System.Data.DataRowView)rowData;
            }
        }

        [ConnectionConsumer("Row of Data", "RowData")]
        public void BANFDetailsConsumer(IWebPartRow provider)
        {
            _wpRowProvider = provider;
        }
       
        

       
    }

    
    
}
