﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.WebControls;

using ERPConnectServices;
using BANF;

namespace BANF.BdcModelBANF
{

    public class BANFService
    {

        static BANF CreateEntity(REQUISITION_ITEMSStructure1 item, REQUISITION_ACCOUNT_ASSIGNMENTStructure1 account)
        {
            BANF entity = new BANF();

            entity.RequisitionNumber = item.RequisitionNumber;
            entity.RequisitionItem = item.RequisitionItem;
            entity.DocumentType = item.DocumentType;
            entity.DocumentCategory = item.DocumentCategory;
            entity.PurchasingGroup = item.PurchasingGroup;
            entity.Requisitioner = item.Requisitioner;
            entity.MaterialDescription = item.MaterialDescription;
            entity.Material = item.Material;
            entity.Plant = item.Plant;
            entity.MaterialGroup = item.MaterialGroup;
            entity.Quantity = item.Quantity;
            entity.Unit = item.Unit;
            entity.Amount = item.Amount;
            entity.Currency = item.Currency;
            entity.AcctAssignmentCategory = item.AcctAssignmentCategory;
            entity.RequisitionDate = item.RequisitionDate;
            entity.DeliveryDate = item.DeliveryDate;
            entity.ReleaseDate = item.ReleaseDate;
            entity.ReleaseIndicator = item.ReleaseIndicator;
            entity.ReleaseStatus = item.ReleaseStatus;
            entity.ReleaseStrategy = item.ReleaseStrategy;
            entity.ReleaseGroup = item.ReleaseGroup;
            entity.SubjectToRelease = item.SubjectToRelease;
            entity.CreatedBy = item.CreatedBy;
            entity.ModifiedOn = item.ModifiedOn;
            entity.GLAccount = account != null ? account.GLAccount : String.Empty;
            entity.CostCenter = account != null ? account.CostCenter : String.Empty;

            return entity;
        }

        static BANF CreateEntity(REQUISITION_ITEMSStructure2 item)
        {
            BANF entity = new BANF();

            entity.RequisitionNumber = item.RequisitionNumber;
            entity.RequisitionItem = item.RequisitionItem;
            entity.DocumentType = item.DocumentType;
            entity.DocumentCategory = String.Empty;
            entity.PurchasingGroup = item.PurchasingGroup;
            entity.Requisitioner = item.Requisitioner;
            entity.MaterialDescription = item.MaterialDescription;
            entity.Material = item.Material;
            entity.Plant = item.Plant;
            entity.MaterialGroup = item.MaterialGroup;
            entity.Quantity = item.Quantity;
            entity.Unit = item.Unit;
            entity.Amount = item.Amount;
            entity.Currency = item.Currency;
            entity.AcctAssignmentCategory = item.AcctAssignmentCategory;
            entity.RequisitionDate = item.RequisitionDate;
            entity.DeliveryDate = item.DeliveryDate;
            entity.ReleaseDate = item.ReleaseDate;
            entity.ReleaseIndicator = String.Empty;
            entity.ReleaseStatus = String.Empty;
            entity.ReleaseStrategy = String.Empty;
            entity.ReleaseGroup = String.Empty;
            entity.SubjectToRelease = String.Empty;
            entity.CreatedBy = item.CreatedBy;
            entity.ModifiedOn = String.Empty;
            entity.GLAccount = String.Empty;
            entity.CostCenter = String.Empty;

            return entity;
        }

        static BANF CreateEntity(REQUISITION_ITEMSStructure9 item)
        {
            BANF entity = new BANF();

            entity.RequisitionNumber = item.RequisitionNumber;
            entity.RequisitionItem = item.RequisitionItem;
            entity.DocumentType = item.DocumentType;
            entity.DocumentCategory = String.Empty;
            entity.PurchasingGroup = item.PurchasingGroup;
            entity.Requisitioner = String.Empty;
            entity.MaterialDescription = item.MaterialDescription;
            entity.Material = item.Material;
            entity.Plant = item.Plant;
            entity.MaterialGroup = item.MaterialGroup;
            entity.Quantity = item.Quantity;
            entity.Unit = item.Unit;
            entity.Amount = item.Amount;
            entity.Currency = item.Currency;
            entity.AcctAssignmentCategory = item.AcctAssignmentCategory;
            entity.RequisitionDate = item.RequisitionDate;
            entity.DeliveryDate = item.DeliveryDate;
            entity.ReleaseDate = item.ReleaseDate;
            entity.ReleaseIndicator = String.Empty;
            entity.ReleaseStatus = String.Empty;
            entity.ReleaseStrategy = String.Empty;
            entity.ReleaseGroup = String.Empty;
            entity.SubjectToRelease = String.Empty;
            entity.CreatedBy = item.CreatedBy;
            entity.ModifiedOn = String.Empty;
            entity.GLAccount = String.Empty;
            entity.CostCenter = String.Empty;

            return entity;
        }

        static BANF CreateEntity(REQUISITION_ITEMSStructure3 item, REQUISITION_ACCOUNT_ASSIGNMENTStructure3 account)
        {
            BANF entity = new BANF();

            entity.RequisitionNumber = item.RequisitionNumber;
            entity.RequisitionItem = item.RequisitionItem;
            entity.DocumentType = item.DocumentType;
            entity.DocumentCategory = String.Empty;
            entity.PurchasingGroup = item.PurchasingGroup;
            entity.Requisitioner = item.Requisitioner;
            entity.MaterialDescription = item.MaterialDescription;
            entity.Material = item.Material;
            entity.Plant = item.Plant;
            entity.MaterialGroup = String.Empty;
            entity.Quantity = item.Quantity;
            entity.Unit = item.Unit;
            entity.Amount = item.Amount;
            entity.Currency = item.Currency;
            entity.AcctAssignmentCategory = item.AcctAssignmentCategory;
            entity.RequisitionDate = item.RequisitionDate;
            entity.DeliveryDate = item.DeliveryDate;
            entity.ReleaseDate = item.ReleaseDate;
            entity.ReleaseIndicator = String.Empty;
            entity.ReleaseStatus = String.Empty;
            entity.ReleaseStrategy = String.Empty;
            entity.ReleaseGroup = String.Empty;
            entity.SubjectToRelease = String.Empty;
            entity.CreatedBy = item.CreatedBy;
            entity.ModifiedOn = String.Empty;
            entity.GLAccount = account != null ? account.GLAccount : String.Empty;
            entity.CostCenter = account != null ? account.CostCenter : String.Empty;

            return entity;
        }

        static void ParseEntity(BANFCreate newbanf, out REQUISITION_ITEMSTable3 item_table, out REQUISITION_ACCOUNT_ASSIGNMENTTable3 account_table)
        {
            item_table = new REQUISITION_ITEMSTable3();
            account_table = new REQUISITION_ACCOUNT_ASSIGNMENTTable3();
            REQUISITION_ITEMSStructure3 item = new REQUISITION_ITEMSStructure3();
            REQUISITION_ACCOUNT_ASSIGNMENTStructure3 account = new REQUISITION_ACCOUNT_ASSIGNMENTStructure3();

            item.AcctAssignmentCategory = newbanf.AcctAssignmentCategory;
            item.DocumentType = newbanf.DocumentType;
            item.MaterialDescription = newbanf.MaterialDescription;
            item.Material = newbanf.Material;
            item.Plant = newbanf.Plant;
            item.Quantity = newbanf.Quantity;
            item.DeliveryDate = newbanf.DeliveryDate;
            item.PurchasingGroup = newbanf.PurchasingGroup;
            item.Requisitioner = newbanf.Requisitioner;
            account.CostCenter = newbanf.CostCenter.PadLeft(10, '0');
            account.GLAccount = newbanf.GLAccount;

            item_table.Add(item);
            account_table.Add(account);
        }

        public static BANF ReadItem(string preq_no, string preq_item)
        {
            using (ERPConnectServicesContext context = new ERPConnectServicesContext())
            {
                string account_ind = "X";
                REQUISITION_ACCOUNT_ASSIGNMENTTable1 account_table = new REQUISITION_ACCOUNT_ASSIGNMENTTable1();
                REQUISITION_ITEMSTable1 item_table = new REQUISITION_ITEMSTable1();

                RETURNTable1 bapi_ret = context.BAPI_REQUISITION_GETDETAIL(account_ind, preq_no, ref account_table, ref item_table);

                REQUISITION_ITEMSStructure1 item = item_table.Where(i => i.RequisitionItem == preq_item).FirstOrDefault();
                REQUISITION_ACCOUNT_ASSIGNMENTStructure1 account = account_table.Where(i => i.RequisitionItem == preq_item).FirstOrDefault();

                return CreateEntity(item, account);
            }
        }

        public static IEnumerable<BANF> ReadList(int limit, string items_for_release, string rel_group, string rel_code)
        {
            using (ERPConnectServicesContext context = new ERPConnectServicesContext())
            {
                if (items_for_release == null) items_for_release = "X";
                if (rel_group == null) rel_group = String.Empty;
                if (rel_code == null) rel_code = String.Empty;

                REQUISITION_ITEMSTable9 preq_itemlist = new REQUISITION_ITEMSTable9();
                RETURNTable9 bapi_ret = context.BAPI_REQUISITION_GETITEMSREL(items_for_release, rel_code, rel_group, ref preq_itemlist);
                
                
                //RETURNTable2 bapi_ret = context.BAPI_REQUISITION_GETITEMSREL(material, plant, pur_group, ref preq_itemlist);

                List<BANF> list = new List<BANF>();

                if (limit == -1)
                {
                    foreach (REQUISITION_ITEMSStructure9 item in preq_itemlist)
                    {
                        list.Add(CreateEntity(item));
                    }
                }
                else
                {
                    int rowCount = 0;
                    foreach (REQUISITION_ITEMSStructure9 item in preq_itemlist)
                    {
                        if (rowCount++ < limit)
                            list.Add(CreateEntity(item));
                    }
                }

                return list;
            }
        }

        public static BANF Create(BANFCreate newbanf)
        {
            using (ERPConnectServicesContext context = new ERPConnectServicesContext())
            {
                REQUISITION_ITEMSTable3 item_table = new REQUISITION_ITEMSTable3();
                REQUISITION_ACCOUNT_ASSIGNMENTTable3 account_table = new REQUISITION_ACCOUNT_ASSIGNMENTTable3();
                ParseEntity(newbanf, out item_table, out account_table);

                RETURNTable3 bapi_ret = context.BAPI_REQUISITION_CREATE(ref account_table, ref item_table);

                REQUISITION_ITEMSStructure3 item = item_table.FirstOrDefault();
                REQUISITION_ACCOUNT_ASSIGNMENTStructure3 account = account_table.FirstOrDefault();

                return CreateEntity(item, account);
            }
        }

        public static void Update(BANFUpdate banf)
        {
            using (ERPConnectServicesContext context = new ERPConnectServicesContext())
            {
                string preq_no = banf.RequisitionNumber;
                string preq_item = banf.RequisitionItem;

                REQUISITION_ITEMS_OLDTable item_table_old = new REQUISITION_ITEMS_OLDTable();
                REQUISITION_ITEMS_NEWTable item_table_new = new REQUISITION_ITEMS_NEWTable();
                REQUISITION_ITEMS_OLDStructure item_old = new REQUISITION_ITEMS_OLDStructure();
                REQUISITION_ITEMS_NEWStructure item_new = new REQUISITION_ITEMS_NEWStructure();


                //get old item
                string account_ind = "X";
                REQUISITION_ACCOUNT_ASSIGNMENTTable1 account_table = new REQUISITION_ACCOUNT_ASSIGNMENTTable1();
                REQUISITION_ITEMSTable1 item_table = new REQUISITION_ITEMSTable1();

                RETURNTable1 bapi_ret_getdetail = context.BAPI_REQUISITION_GETDETAIL(account_ind, preq_no, ref account_table, ref item_table);

                REQUISITION_ITEMSStructure1 item = item_table.Where(i => i.RequisitionItem == preq_item).FirstOrDefault();
                REQUISITION_ACCOUNT_ASSIGNMENTStructure1 account = account_table.Where(i => i.RequisitionItem == preq_item).FirstOrDefault();

                item_old.AGMT_ITEM = item.AGMT_ITEM;
                item_old.AGREEMENT = item.AGREEMENT;
                item_old.Amount = item.Amount;
                item_old.BATCH = item.BATCH;
                item_old.Currency = item.Currency;
                item_old.DEL_DATCAT = item.DEL_DATCAT;
                item_old.DeliveryDate = item.DeliveryDate;
                item_old.DES_VENDOR = item.DES_VENDOR;
                item_old.DISTRIB = item.DISTRIB;
                item_old.FIXED_VEND = item.FIXED_VEND;
                item_old.GR_IND = item.GR_IND;
                item_old.GR_NON_VAL = item.GR_NON_VAL;
                item_old.GR_PR_TIME = item.GR_PR_TIME;
                item_old.INFO_REC = item.INFO_REC;
                item_old.INT_OBJ_NO = item.INT_OBJ_NO;
                item_old.IR_IND = item.IR_IND;
                item_old.MaterialDescription = item.MaterialDescription;
                item_old.MaterialGroup = item.MaterialGroup;
                item_old.PART_INV = item.PART_INV;
                item_old.PCKG_NO = item.PCKG_NO;
                item_old.PO_PRICE = item.PO_PRICE;
                item_old.PO_UNIT = item.PO_UNIT;
                item_old.PRICE_UNIT = item.PRICE_UNIT;
                item_old.PROMOTION = item.PROMOTION;
                item_old.PURCH_ORG = item.PURCH_ORG;
                item_old.PurchasingGroup = item.PurchasingGroup;
                item_old.Quanitity = item.Quantity;
                item_old.ReleaseDate = item.ReleaseDate;
                item_old.RequisitionItem = item.RequisitionItem;
                item_old.STORE_LOC = item.STORE_LOC;
                item_old.TRACKINGNO = item.TRACKINGNO;
                item_old.Unit = item.Unit;
                item_old.VAL_TYPE = item.VAL_TYPE;
                item_old.VEND_MAT = item.VEND_MAT;

                item_table_old.Add(item_old);


                //define new item
                item_new.AGMT_ITEM = item_old.AGMT_ITEM; //read-only field
                item_new.Amount = item_old.Amount; //read-only field
                item_new.DEL_DATCAT = item_old.DEL_DATCAT; //read-only field
                item_new.DeliveryDate = banf.DeliveryDate;
                item_new.GR_IND = item_old.GR_IND; //read-only field
                item_new.GR_PR_TIME = item_old.GR_PR_TIME; //read-only field
                item_new.INT_OBJ_NO = item_old.INT_OBJ_NO; //read-only field
                item_new.IR_IND = item_old.IR_IND; //read-only field
                item_new.MaterialDescription = banf.MaterialDescription;
                item_new.MaterialGroup = item_old.MaterialGroup; //read-only field
                item_new.PCKG_NO = item_old.PCKG_NO; //read-only field
                item_new.PRICE_UNIT = item_old.PRICE_UNIT; //read-only field
                item_new.PurchasingGroup = banf.PurchasingGroup;
                if (item.ReleaseStatus == "") //BANF is released and quantity cannot be changed
                {
                    item_new.Quantity = banf.Quantity;
                }
                else
                {
                    item_new.Quantity = item_old.Quanitity;
                }
                item_new.ReleaseDate = item_old.ReleaseDate; //read-only field
                item_new.RequisitionItem = banf.RequisitionItem; //read-only field
                item_new.STORE_LOC = item_old.STORE_LOC; //read-only field
                item_new.Unit = item_old.Unit; //read-only field

                item_table_new.Add(item_new);

                RETURNTable4 bapi_ret = context.BAPI_REQUISITION_CHANGE(preq_no, ref item_table_new, ref item_table_old);

            }

        }

        public static void Delete(string preq_no, string preq_item)
        {
            using (ERPConnectServicesContext context = new ERPConnectServicesContext())
            {
                REQUISITION_ITEMS_TO_DELETETable item_table_del = new REQUISITION_ITEMS_TO_DELETETable();
                REQUISITION_ITEMS_TO_DELETEStructure item_del = new REQUISITION_ITEMS_TO_DELETEStructure();
                item_del.RequisitionItem = preq_item;
                item_del.DELETE_IND = "X";
                item_table_del.Add(item_del);

                RETURNTable5 bapi_ret = context.BAPI_REQUISITION_DELETE(preq_no, ref item_table_del);

            }
        }

        public static void Release(string preq_no, string preq_item)
        {
            using (ERPConnectServicesContext context = new ERPConnectServicesContext())
            {
                GENERAL_RELEASE_INFOTable rel_info_table = new GENERAL_RELEASE_INFOTable();
                RELEASE_ALREADY_POSTEDTable rel_posted_table = new RELEASE_ALREADY_POSTEDTable();
                RELEASE_FINALTable rel_final_table = new RELEASE_FINALTable();

                RETURNTable6 bapi_ret_relinfo = context.BAPI_REQUISITION_GETRELINFO(preq_item, preq_no, ref rel_info_table, ref rel_posted_table, ref rel_final_table);

                RELEASE_FINALStructure rel_final_item = rel_final_table.Where(i => i.PREQ_ITEM == preq_item).FirstOrDefault();
                string rel_code = String.Empty;
                if (rel_posted_table.RowCount == 0)
                {
                    rel_code = rel_final_item.REL_CODE1;
                }
                else
                {
                    RELEASE_ALREADY_POSTEDStructure rel_posted_item = rel_posted_table.Where(p => p.PREQ_ITEM == preq_item).FirstOrDefault();
                    string[] prev_rel_codes = new string[8] { rel_posted_item.REL_CODE1, rel_posted_item.REL_CODE2, rel_posted_item.REL_CODE3, rel_posted_item.REL_CODE4, rel_posted_item.REL_CODE5, rel_posted_item.REL_CODE6, rel_posted_item.REL_CODE7, rel_posted_item.REL_CODE8 };
                    string[] final_rel_codes = new string[8] { rel_final_item.REL_CODE1, rel_final_item.REL_CODE2, rel_final_item.REL_CODE3, rel_final_item.REL_CODE4, rel_final_item.REL_CODE5, rel_final_item.REL_CODE6, rel_final_item.REL_CODE7, rel_final_item.REL_CODE8 };
                    int i = 0;
                    while (prev_rel_codes[i] != String.Empty)
                    {
                        rel_code = final_rel_codes[i + 1];
                        i++;
                    }
                };

                string rel_indicator;
                string rel_status;

                RETURNTable7 bapi_ret = context.BAPI_REQUISITION_RELEASE(out rel_indicator, out rel_status, preq_item, preq_no, rel_code);
            }
        }

        public static void ResetRelease(string preq_no, string preq_item)
        {
            using (ERPConnectServicesContext context = new ERPConnectServicesContext())
            {
                GENERAL_RELEASE_INFOTable rel_info_table = new GENERAL_RELEASE_INFOTable();
                RELEASE_ALREADY_POSTEDTable rel_posted_table = new RELEASE_ALREADY_POSTEDTable();
                RELEASE_FINALTable rel_final_table = new RELEASE_FINALTable();

                RETURNTable6 bapi_ret_relinfo = context.BAPI_REQUISITION_GETRELINFO(preq_item, preq_no, ref rel_info_table, ref rel_posted_table, ref rel_final_table);

                if (rel_posted_table.RowCount == 0)
                {
                    //reset not possible
                }
                else
                {
                    RELEASE_ALREADY_POSTEDStructure rel_posted_item = rel_posted_table.Where(p => p.PREQ_ITEM == preq_item).FirstOrDefault();
                    string[] prev_rel_codes = new string[8] { rel_posted_item.REL_CODE1, rel_posted_item.REL_CODE2, rel_posted_item.REL_CODE3, rel_posted_item.REL_CODE4, rel_posted_item.REL_CODE5, rel_posted_item.REL_CODE6, rel_posted_item.REL_CODE7, rel_posted_item.REL_CODE8 };
                    string rel_code = String.Empty;
                    int i = 0;
                    while (prev_rel_codes[i] != String.Empty)
                    {
                        i++;
                        rel_code = prev_rel_codes[i - 1];
                    }

                    string rel_indicator;
                    string rel_status;

                    RETURNTable8 bapi_ret = context.BAPI_REQUISITION_RESET_RELEASE(out rel_indicator, out rel_status, preq_item, preq_no, rel_code);
                }
            }
        }

        public static IEnumerable<T024> BANFToPurchasingGroup(string requisitionNumber, string requisitionItem)
        {
            //BANF banfItem = ReadItem(requisitionNumber, requisitionItem);
            //using (ERPConnectServicesContext context = new ERPConnectServicesContext())
            //{
            //    IEnumerable<T024> purch_groups = (from t in context.T024List where t.EKGRP == banfItem.PurchasingGroup select t);
            //    return purch_groups;
            //}
            throw new System.NotImplementedException();
            
        }

        public static IEnumerable<DocumentType> BANFToDocumentType(string requisitionNumber, string requisitionItem)
        {
            throw new System.NotImplementedException();
        }

        public static IEnumerable<AcctAssignmentCat> BANFToAcctAssignmentCat(string requisitionNumber, string requisitionItem)
        {
            throw new System.NotImplementedException();
        }
    }
}
