﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
namespace BANF.BdcModelBANF
{
    public partial class DocumentTypeService
    {
        public static DocumentType ReadItem(string typeCode)
        {
            using (ERPConnectServicesContext context = new ERPConnectServicesContext())
            {
                string lang = "EN";
                T161T doc_type = (from t in context.T161TList where (t.BSART == typeCode && t.SPRAS == lang) select t).FirstOrDefault();
                DocumentType dt = new DocumentType();
                dt.TypeCode = doc_type.BSART;
                dt.Description = doc_type.BATXT;
                return dt;
            }
        }

        public static IEnumerable<DocumentType> ReadList()
        {
            using (ERPConnectServicesContext context = new ERPConnectServicesContext())
            {
                string lang = "EN";
                IEnumerable<T161T> doc_types = (from t in context.T161TList where t.SPRAS == lang select t);

                List<DocumentType> list = new List<DocumentType>();

                foreach (T161T item in doc_types)
                {
                    DocumentType dt = new DocumentType();
                    dt.TypeCode = item.BSART;
                    dt.Description = item.BATXT;
                    list.Add(dt);
                }
                return list;
            }
        }

        public static IEnumerable<BANF> DocumentTypeToBANF(string typeCode)
        {
            throw new System.NotImplementedException();
        }
    }
}
