﻿using System;
using System.Linq;
using System.Text;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Collections.Generic;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;
using ERPConnectServices;

namespace BANF.ControlTemplates.BANF
{
    public partial class BANFListFilter : UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                using (ERPConnectServicesContext context = new ERPConnectServicesContext())
                {
                    var releaseGroups = (from g in context.T16FHList where g.SPRAS == "EN" select g).OrderBy(g => g.FRGGR);
                    List<T16FH> releaseGroupsDisplay = new List<T16FH>();
                    foreach (T16FH rg in releaseGroups)
                    {
                        rg.FRGGT = rg.FRGGR + " - " + rg.FRGGT;
                        releaseGroupsDisplay.Add(rg);
                    }
                    ddlReleaseGroups.DataSource = releaseGroupsDisplay;
                    ddlReleaseGroups.DataTextField = "FRGGT";
                    ddlReleaseGroups.DataValueField = "FRGGR";
                    ddlReleaseGroups.DataBind();
                    HtmlInputHidden inputHiddenValue3 = (HtmlInputHidden)this.Parent.FindControl("inputHiddenValue3");
                    inputHiddenValue3.Value = ddlReleaseGroups.SelectedValue;
                    TextBox tbxFilterValue3 = (TextBox)this.Parent.FindControl("tbxFilterValue3");
                    tbxFilterValue3.Text = ddlReleaseGroups.SelectedValue;

                    var releaseCodes = (from c in context.T16FDList where c.SPRAS == "EN" select c).OrderBy(c => c.FRGCO);
                    List<T16FD> releaseCodesDisplay = new List<T16FD>();
                    foreach (T16FD rc in releaseCodes)
                    {
                        rc.FRGCT = rc.FRGCO + " - " + rc.FRGCT;
                        releaseCodesDisplay.Add(rc);
                    }
                    ddlReleaseCodes.DataSource = releaseCodesDisplay;
                    ddlReleaseCodes.DataTextField = "FRGCT";
                    ddlReleaseCodes.DataValueField = "FRGCO";
                    ddlReleaseCodes.DataBind();
                    HtmlInputHidden inputHiddenValue2 = (HtmlInputHidden)this.Parent.FindControl("inputHiddenValue2");
                    inputHiddenValue2.Value = ddlReleaseCodes.SelectedValue;
                    TextBox tbxFilterValue2 = (TextBox)this.Parent.FindControl("tbxFilterValue2");
                    tbxFilterValue2.Text = ddlReleaseCodes.SelectedValue;

                }
                cbItemsForRelease.Checked = true;
                HtmlInputHidden inputHiddenValue1 = (HtmlInputHidden)this.Parent.FindControl("inputHiddenValue1");
                inputHiddenValue1.Value = "X";
                TextBox tbxFilterValue1 = (TextBox)this.Parent.FindControl("tbxFilterValue1");
                tbxFilterValue1.Text = "X";
            
            }

        }

        protected void ReleaseCodes_SelectedIndexChanged(object sender, EventArgs e)
        {
            HtmlInputHidden inputHiddenValue2 = (HtmlInputHidden)this.Parent.FindControl("inputHiddenValue2");
            inputHiddenValue2.Value = ddlReleaseCodes.SelectedValue;
            TextBox tbxFilterValue2 = (TextBox)this.Parent.FindControl("tbxFilterValue2");
            tbxFilterValue2.Text = ddlReleaseCodes.SelectedValue;
        }

        protected void ReleaseGroups_SelectedIndexChanged(object sender, EventArgs e)
        {
            HtmlInputHidden inputHiddenValue3 = (HtmlInputHidden)this.Parent.FindControl("inputHiddenValue3");
            inputHiddenValue3.Value = ddlReleaseGroups.SelectedValue;
            TextBox tbxFilterValue3 = (TextBox)this.Parent.FindControl("tbxFilterValue3");
            tbxFilterValue3.Text = ddlReleaseGroups.SelectedValue;
        }

        protected void Refresh_Click(object sender, EventArgs e)
        {

       
        }

        protected void ItemsForRelease_CheckedChanged(object sender, EventArgs e)
        {
            HtmlInputHidden inputHiddenValue1 = (HtmlInputHidden)this.Parent.FindControl("inputHiddenValue1");
            TextBox tbxFilterValue1 = (TextBox)this.Parent.FindControl("tbxFilterValue1");
            if (cbItemsForRelease.Checked)
            {
                tbxFilterValue1.Text = "X";
                inputHiddenValue1.Value = "X";
            }
            else
            {
                tbxFilterValue1.Text = " ";
                inputHiddenValue1.Value = " ";
            }
        }

        protected void Customize_List_Ribbon(object sender, EventArgs e)
        {
            //add Release button to page ribbon

            //            string siteUrl = SPContext.Current.Site.Url;
            //            string webUrlrel = SPContext.Current.Web.Url.Remove(0, siteUrl.Length);

            //            using (SPSite site = new SPSite(SPContext.Current.Site.Url))
            //            {
            //                using (SPWeb web = site.OpenWeb(webUrlrel))
            //                {
            //                    web.AllowUnsafeUpdates = true;
            //                    SPList list = web.Lists["BANFList"];
            //                    if (list != null)
            //                    {
            //                        var action = list.UserCustomActions.Add();
            //                        action.Location = "CommandUI.Ribbon.ListView";
            //                        action.Title = "Release Item";
            //                        action.CommandUIExtension =
            //                            @"<CommandUIExtension><CommandUIDefinitions>
            //                                <CommandUIDefinition Location=""Ribbon.ListItem.Groups._children"">
            //                                <Group Id=""Ribbon.ListItem.CustomGroup"" Sequence=""25"" Description=""Purchasing Actions"" Title=""Purchasing"" Command=""EnableCustomGroup"" Template=""Ribbon.Templates.Flexible2"">
            //                                <Controls Id=""ListViewCustomGroup.Controls"">
            //                                <Button Id=""ListViewCustomGroup.Release"" Command=""ReleaseButtonCommand"" Description=""Release"" LabelText=""Release Item"" Image32by32=""/_layouts/images/banf/ReleaseIcon32x32.png"" TemplateAlias=""o1"" />
            //                                </Controls>
            //                                </Group>
            //                                </CommandUIDefinition>
            //                                <CommandUIDefinition Location=""Ribbon.ListItem.Scaling._children"">
            //                                <MaxSize Id =""Ribbon.ListItem.Scaling.CustomGroup.MaxSize"" Sequence=""15"" GroupId=""Ribbon.ListItem.CustomGroup"" Size =""LargeLarge"" />
            //                                </CommandUIDefinition>
            //                                </CommandUIDefinitions>
            //                                <CommandUIHandlers>
            //                                <CommandUIHandler Command=""EnableCustomGroup"" CommandAction=""javascript:return true;"" />
            //                                <CommandUIHandler Command=""ReleaseButtonCommand"" CommandAction=""javascript:releaseButtonClick('{SiteUrl}');"" />
            //                                </CommandUIHandlers>
            //                                </CommandUIExtension>";
            //                        action.Update();
            //                    }
            //                }
            //            }

        }
    }  
}
