﻿using System;
using System.Collections;
using System.Linq;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;


namespace BANF.Layouts.BANF
{
    public partial class BANFRelease : LayoutsPageBase
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Request.QueryString["list"] != null && Request.QueryString["items"] != null)
            {
                string list = Request.QueryString["list"];
                string[] items = Request.QueryString["items"].ToString().Split(',');
                
                string[] itemsnew = new string[items.Length -1];
                for (int i = 0; i < items.Length -1; i++)
                {
                    itemsnew[i] = items[i];
                }
                                
                Guid listGuid = new Guid(list);
                SPWeb web = SPContext.Current.Web;
                SPList banfList = web.Lists[listGuid];
                SPQuery query = new SPQuery();
                string whereClause = "";
                foreach (string bdcId in itemsnew)
                {
                    whereClause += "<Eq><FieldRef Name=\"BdcIdentity\"/>" +
                                       "<Value Type=\"Text\">" + bdcId + "</Value>" +
                                   "</Eq>";
                }
                if (itemsnew.Length > 1)
                {
                    whereClause = "<Or>" + whereClause + "</Or>";
                }
                query.ViewXml = "<View>" +
                                   "<Method Name=\"ReadList\">" +
                                      "<Filter Name=\"Limit\" Value=\"500\"/>" +
                                      "<Filter Name=\"ItemsForRelease\" Value=\"X\"/>" +
                                      "<Filter Name=\"ReleaseGroup\" Value=\"01\"/>" +
                                      "<Filter Name=\"ReleaseCode\" Value=\"KY\"/>" +
                                   "</Method>" +
                                   "<Query>" +
                                      "<Where>" + whereClause + "</Where>" +
                                   "</Query>" +
                                   "<ViewFields>" +
                                     "<FieldRef Name=\"RequisitionNumber\"/>" +
                                     "<FieldRef Name=\"RequisitionItem\"/>" +
                                     "<FieldRef Name=\"Material\"/>" +
                                     "<FieldRef Name=\"MaterialDescription\"/>" +
                                     "<FieldRef Name=\"Quantity\"/>" +
                                     "<FieldRef Name=\"Unit\"/>" +
                                   "</ViewFields>" +
                                "</View>";
                SPListItemCollection listItems = banfList.GetItems(query);
                
                            
                foreach (SPListItem item in listItems)
                {
                    string reqNumber = item["RequisitionNumber"].ToString();
                    string reqItem = item["RequisitionItem"].ToString();
                    string material = item["Material"].ToString();
                    string description = item["MaterialDescription"].ToString();
                    string qty = item["Quantity"].ToString();
                    string unit = item["Unit"].ToString();
                }

                gvItems.DataSource = listItems.GetDataTable();
                gvItems.DataBind();
            }
        }


        protected void GetBANFItem(string itemId)
        {

            const string entityName = "BANF";
            const string lobSystemName = "BdcModelBANF";
            const string entityNamespace = "BANF.BdcModelBANF";
            using (SPSite site = new SPSite(SPContext.Current.Web.Url))
            {
                using (new Microsoft.SharePoint.SPServiceContextScope(SPServiceContext.GetContext(site)))
                {
                    //BdcService service = SPFarm.Local.Services.GetValue<BdcService>(String.Empty);
                    //IMetadataCatalog catalog = service.GetDatabaseBackedMetadataCatalog(SPServiceContext.Current);
                    //IEntity entity = catalog.GetEntity(entityNamespace, entityName);
                    //ILobSystemInstance lobSystemInstance = entity.GetLobSystem().GetLobSystemInstances()[0].Value;
                    //IMethodInstance methodInstance = entity.GetMethodInstance("ReadItem", MethodInstanceType.SpecificFinder);
                    //Identity id = new Identity(itemId);
                    //IEntityInstance ientityInstance = entity.FindSpecific(id, lobSystemInstance);
                }
            }
        }
        
        protected void btnRelease_Click(Object sender, EventArgs e)
        {
            //release BANF

        }
    }
}
