﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:x="http://www.w3.org/2001/XMLSchema" xmlns:d="http://schemas.microsoft.com/sharepoint/dsp" version="1.0" exclude-result-prefixes="xsl msxsl ddwrt" xmlns:ddwrt="http://schemas.microsoft.com/WebParts/v2/DataView/runtime" xmlns:asp="http://schemas.microsoft.com/ASPNET/20" xmlns:__designer="http://schemas.microsoft.com/WebParts/v2/DataView/designer" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:SharePoint="Microsoft.SharePoint.WebControls" xmlns:ddwrt2="urn:frontpage:internal" xmlns:o="urn:schemas-microsoft-com:office:office" ddwrt:ghost="show_all">
  <xsl:include href="/_layouts/xsl/main.xsl"/>
  <xsl:include href="/_layouts/xsl/internal.xsl"/>
  <xsl:param name="AllRows" select="/dsQueryResponse/Rows/Row[$EntityName = '' or (position() &gt;= $FirstRow and position() &lt;= $LastRow)]"/>
  <xsl:param name="dvt_apos">&apos;</xsl:param>
  <xsl:template match="/" ddwrt:ghost="hide">
    <xsl:choose>
      <xsl:when test="$RenderCTXOnly='True'">
        <xsl:call-template name="CTXGeneration"/>
      </xsl:when>
      <xsl:when test="($ManualRefresh = 'True')">
        <xsl:call-template name="AjaxWrapper" />
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates mode="RootTemplate" select="$XmlDefinition"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="View_Default_RootTemplate" mode="RootTemplate" match="View" ddwrt:dvt_mode="root" ddwrt:ghost="hide">
    <xsl:param name="ShowSelectAllCheckbox" select="'True'"/>
    <xsl:if test="($IsGhosted = '0' and $MasterVersion=3 and Toolbar[@Type='Standard']) or $ShowAlways">
      <xsl:call-template name="ListViewToolbar"/>
    </xsl:if>
    <table width="100%" cellspacing="0" cellpadding="0" border="0">
      <xsl:if test="not($NoCTX)">
        <xsl:call-template name="CTXGeneration"/>
      </xsl:if>
      <xsl:if test="List/@TemplateType=109">
        <xsl:call-template name="PicLibScriptGeneration"/>
      </xsl:if>
      <tr>
        <td>
          <xsl:if test="not($NoAJAX)">
            <iframe src="javascript:false;" id="FilterIframe{$ViewCounter}" name="FilterIframe{$ViewCounter}" style="display:none" height="0" width="0" FilterLink="{$FilterLink}"></iframe>
          </xsl:if>
          <table summary="{List/@title} {List/@description}" xmlns:o="urn:schemas-microsoft-com:office:office" o:WebQuerySourceHref="{$HttpPath}&amp;XMLDATA=1&amp;RowLimit=0&amp;View={$View}"
                          width="100%" border="0" cellspacing="0" dir="{List/@Direction}">
            <xsl:if test="not($NoCTX)">
              <xsl:attribute name="onmouseover">
                EnsureSelectionHandler(event,this,<xsl:value-of select ="$ViewCounter"/>)
              </xsl:attribute>
            </xsl:if>
            <xsl:if test="$NoAJAX">
              <xsl:attribute name="FilterLink">
                <xsl:value-of select="$FilterLink"/>
              </xsl:attribute>
            </xsl:if>
            <xsl:attribute name="cellpadding">
              <xsl:choose>
                <xsl:when test="ViewStyle/@ID='15' or ViewStyle/@ID='16'">0</xsl:when>
                <xsl:otherwise>1</xsl:otherwise>
              </xsl:choose>
            </xsl:attribute>
            <xsl:attribute name="id">
              <xsl:choose>
                <xsl:when test="$IsDocLib or dvt_RowCount = 0">onetidDoclibViewTbl0</xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="concat($List, '-', $View)"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:attribute>
            <xsl:attribute name="class">
              <xsl:choose>
                <xsl:when test="ViewStyle/@ID='0' or ViewStyle/@ID='17'">
                  <xsl:value-of select="$ViewClassName"/> ms-basictable
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="$ViewClassName"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:attribute>
            <xsl:if test="$InlineEdit">
              <xsl:attribute name="inlineedit">
                javascript: <xsl:value-of select="ddwrt:GenFireServerEvent('__cancel;dvt_form_key={@ID}')"/>;CoreInvoke('ExpGroupOnPageLoad', 'true');
              </xsl:attribute>
            </xsl:if>
            <xsl:apply-templates select="." mode="full">
              <xsl:with-param name="ShowSelectAllCheckbox" select="$ShowSelectAllCheckbox"/>
            </xsl:apply-templates>
          </table>
          <xsl:choose>
            <xsl:when test="$IsDocLib or dvt_RowCount = 0">
              <script type='text/javascript'>HideListViewRows("onetidDoclibViewTbl0");</script>
            </xsl:when>
            <xsl:otherwise>
              <script type='text/javascript'>
                <xsl:value-of select ="concat('HideListViewRows(&quot;', $List, '-', $View, '&quot;);')"/>
              </script>
            </xsl:otherwise>
          </xsl:choose>
        </td>
      </tr>
      <xsl:if test="$dvt_RowCount = 0 and not (@BaseViewID='3' and List/@TemplateType='102')">
        <tr>
          <td>
            <table width="100%" border="0" dir="{List/@Direction}">
              <xsl:call-template name="EmptyTemplate" />
            </table>
          </td>
        </tr>
      </xsl:if>
    </table>
    <xsl:call-template name="pagingButtons" />
    <xsl:if test="Toolbar[@Type='Freeform'] or ($MasterVersion=4 and Toolbar[@Type='Standard'])">
      <xsl:call-template name="Freeform">
        <xsl:with-param name="AddNewText">
          <xsl:choose>
            <xsl:when test="List/@TemplateType='104'">
              <xsl:value-of select="$Rows/@resource.wss.idHomePageNewAnnounce"/>
            </xsl:when>
            <xsl:when test="List/@TemplateType='101' or List/@TemplateType='115'">
              <xsl:value-of select="$Rows/@resource.wss.Add_New_Document"/>
            </xsl:when>
            <xsl:when test="List/@TemplateType='103'">
              <xsl:value-of select="$Rows/@resource.wss.AddNewLink"/>
            </xsl:when>
            <xsl:when test="List/@TemplateType='106'">
              <xsl:value-of select="$Rows/@resource.wss.AddNewEvent"/>
            </xsl:when>
            <xsl:when test="List/@TemplateType='119'">
              <xsl:value-of select="$Rows/@resource.wss.AddNewWikiPage"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$Rows/@resource.wss.addnewitem"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
        <xsl:with-param name="ID">
          <xsl:choose>
            <xsl:when test="List/@TemplateType='104'">idHomePageNewAnnouncement</xsl:when>
            <xsl:when test="List/@TemplateType='101'">idHomePageNewDocument</xsl:when>
            <xsl:when test="List/@TemplateType='103'">idHomePageNewLink</xsl:when>
            <xsl:when test="List/@TemplateType='106'">idHomePageNewEvent</xsl:when>
            <xsl:when test="List/@TemplateType='119'">idHomePageNewWikiPage</xsl:when>
            <xsl:otherwise>idHomePageNewItem</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>
  <xsl:template match="View[ViewStyle/@ID='15' or ViewStyle/@ID='16']" mode="full" ddwrt:ghost="hide">
    <xsl:variable name="Fields" select="ViewFields/FieldRef[not(@Explicit='TRUE')]"/>
    <xsl:variable name="NumColumns" select="count($Fields[not(@Type='Note' or preceding-sibling::*[@Type='Note'])])"/>
    <tr valign="top" class="ms-viewheadertr">
      <xsl:if test="not($GroupingRender)">
        <xsl:apply-templates mode="header" select="$Fields[position() &lt;= $NumColumns]"/>
      </xsl:if>
    </tr>
    <xsl:apply-templates select="." mode="RenderView" />
    <xsl:apply-templates mode="footer" select="." />
  </xsl:template>
  <xsl:template name="FieldRef_header.RequisitionNumber" ddwrt:dvt_mode="header" match="FieldRef[@Name='RequisitionNumber']" mode="header" ddwrt:ghost="hide">
    <th nowrap="nowrap" scope="col" onmouseover="OnChildColumn(this)">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="(@Type='User' or @Type='UserMulti') and ($PresenceEnabled='1')">ms-vh</xsl:when>
          <xsl:otherwise>ms-vh2</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:call-template name="dvt_headerfield.RequisitionNumber">
        <xsl:with-param name="fieldname">
          <xsl:value-of select="@Name"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtitle">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="displayname">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtype">
          <xsl:choose>
            <xsl:when test="@Type='Number' or @Type='Currency'">number</xsl:when>
            <xsl:otherwise>x:string</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </th>
  </xsl:template>
  <xsl:template name="dvt_headerfield.RequisitionNumber" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:variable name="separator" select="' '" />
    <xsl:variable name="connector" select="';'" />
    <xsl:variable name="linkdir">
      <xsl:choose>
        <xsl:when test="$dvt_sortfield = $fieldname and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
        <xsl:otherwise>Asc</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="jsescapeddisplayname">
      <xsl:call-template name="fixQuotes">
        <xsl:with-param name="string" select="$displayname"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$MasterVersion=4 and not($NoAJAX)">
        <div Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
             DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
             class="ms-vh-div">
          <xsl:call-template name="headerfield.RequisitionNumber">
            <xsl:with-param name="fieldname" select ="$fieldname" />
            <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
            <xsl:with-param name="displayname" select="$displayname" />
            <xsl:with-param name="fieldtype" select="$fieldtype"/>
          </xsl:call-template>
        </div>
        <xsl:if test="(not($sortable='FALSE') and not(@FieldType='MultiChoice')) or (not(@Filterable='FALSE') and not(@FieldType='Note') and not(@FieldType='URL'))">
          <div class="s4-ctx">
            <span>&#160;</span>
            <a onfocus="OnChildColumn(this.parentNode.parentNode); return false;" onclick="PopMenuFromChevron(event); return false;" href="javascript:;" title="{$open_menu}">
            </a>
            <span>&#160;</span>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="style">padding:0 !important;border:0 !important;</xsl:attribute>
        <div style="width:100%;position:relative;left:0;top:0;margin:0;border:0">
          <xsl:choose>
            <xsl:when test="$NoAJAX">
              <table CtxNum="{$ViewCounter}" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" name="{$fieldname}" DisplayName="{$displayname}" height="100%">
                <xsl:choose>
                  <xsl:when test="$MasterVersion=4">
                    <xsl:attribute name="style">width:100%;height:27px</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:attribute name="style">width:100%</xsl:attribute>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="$sortable='FALSE'">
                  <xsl:attribute name="Sortable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@Filterable='FALSE'">
                  <xsl:attribute name="Filterable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@FilterDisableMessage">
                  <xsl:attribute name="FilterDisableMessage">
                    <xsl:value-of select="@FilterDisableMessage" />
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test="not($sortable='FALSE') or not(@Filterable='FALSE')">
                  <xsl:attribute name="onmouseover">
                    <xsl:text disable-output-escaping="yes">OnMouseOverAdHocFilter(this, '</xsl:text>
                    <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
                    <xsl:text disable-output-escaping="yes">' , '', '')</xsl:text>
                  </xsl:attribute>
                  <xsl:attribute name="SortFields">
                    <xsl:value-of select="concat($RootFolderParam,$FieldSortParam,'SortField=',@Name,'&amp;SortDir=',$linkdir)"/>
                  </xsl:attribute>
                  <xsl:attribute name="FieldType">
                    <xsl:value-of select="@FieldType"/>
                  </xsl:attribute>
                  <xsl:attribute name="ResultType">
                    <xsl:value-of select="@ResultType"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:call-template name="headerFieldRow.RequisitionNumber">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:when>
            <xsl:otherwise>
              <table style="width:100%;" Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
                 DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
                 height="100%" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" onmouseover="OnMouseOverFilter(this)">
                <xsl:call-template name="headerFieldRow.RequisitionNumber">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </div>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="headerFieldRow.RequisitionNumber" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <tr>
      <td width="100%" class="ms-vb" nowrap="nowrap">
        <xsl:if test="$MasterVersion=4 and $NoAJAX">
          <xsl:attribute name="style">padding-left:0px;padding-top:5px</xsl:attribute>
        </xsl:if>
        <xsl:call-template name="headerfield.RequisitionNumber">
          <xsl:with-param name="fieldname" select ="$fieldname" />
          <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
          <xsl:with-param name="displayname" select="$displayname" />
          <xsl:with-param name="fieldtype" select="$fieldtype"/>
        </xsl:call-template>
      </td>
      <td style="position:absolute;">
        <img src="/_layouts/images/blank.gif" width="13" style="visibility: hidden" alt="" />
      </td>
    </tr>
  </xsl:template>
  <xsl:template name="headerfield.RequisitionNumber" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:choose>
      <xsl:when test="$Filter='1'">
        <xsl:value-of select ="$Rows/@filter.render" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="(@ImnHeader='TRUE') and ($PresenceEnabled='1')">
            <table cellpadding="0" cellspacing="0" dir="{$XmlDefinition/List/@Direction}">
              <tr>
                <td class="ms-imnImgTD">
                  <img border="0" valign="middle" height="12" width="12" altbase="{$idPresEnabled}" src="/_layouts/images/blank.gif" onload="IMNRegisterHeader(event)" id="imnhdr{position()}"/>
                </td>
                <td nowrap="nowrap" class="ms-vh ms-imnTxtTD">
                  <xsl:call-template name="FieldHeader.RequisitionNumber">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </td>
              </tr>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$fieldtype='number'">
                <div align="right" class="ms-numHeader">
                  <xsl:call-template name="FieldHeader.RequisitionNumber">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </div>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="FieldHeader.RequisitionNumber">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select="$fieldtype"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldHeader.RequisitionNumber" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname" />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:param name="thisNode" select="."/>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="not($sortable='FALSE')">
        <xsl:variable name="sortfield">
          <xsl:choose>
            <xsl:when test="substring($fieldname, string-length($fieldname) - 5) = '(text)'">
              <xsl:value-of select="substring($fieldname, 1, string-length($fieldname) - 6)" />
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldname"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="linkdir">
          <xsl:choose>
            <xsl:when test="$dvt_sortfield = $sortfield and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
            <xsl:otherwise>Asc</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="sortText">
          <xsl:choose>
            <xsl:when test="$linkdir='Desc'">&apos; + &apos;descending&apos; + &apos;</xsl:when>
            <xsl:otherwise>&apos; + &apos;ascending&apos; + &apos;</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="jsescapeddisplayname">
          <xsl:call-template name="fixQuotes">
            <xsl:with-param name="string" select="$displayname"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="separator" select="' '" />
        <xsl:variable name="connector" select="';'" />
        <a id="diidSort{$fieldname}" onfocus="OnFocusFilter(this)">
          <xsl:attribute name="href">
            javascript: <xsl:if test="$NoAJAX">
              <xsl:call-template name="GenFireServerEvent">
                <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:attribute>
          <xsl:attribute name="onclick">
            <xsl:choose>
              <xsl:when test="not($NoAJAX)">javascript:return OnClickFilter(this,event);</xsl:when>
              <xsl:otherwise>
                javascript: <xsl:call-template name="GenFireServerEvent">
                  <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
                </xsl:call-template>; event.cancelBubble = true; return false;
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="not($NoAJAX)">
              <xsl:attribute name="SortingFields">
                <xsl:value-of select ="$RootFolderParam"/><xsl:value-of select ="$FieldSortParam"/>SortField=<xsl:value-of select="@Name"/>&amp;SortDir=<xsl:value-of select="$linkdir"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="FilterString">
                <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$fieldtype = 'Attachments'">
              <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <span>Requisition</span>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="$dvt_sortfield = $sortfield">
            <xsl:choose>
              <xsl:when test="$dvt_sortdir = 'ascending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortAsc}" src="{ddwrt:FieldSortImageUrl('Desc')}" />
              </xsl:when>
              <xsl:when test="$dvt_sortdir = 'descending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortDesc}" src="{ddwrt:FieldSortImageUrl('Asc')}" />
              </xsl:when>
            </xsl:choose>
          </xsl:if>
          <img src="/_layouts/images/blank.gif" class="ms-hidden" border="0" width="1" height="1" alt="{$OpenMenuKeyAccessible}"/>
        </a>
        <img src="/_layouts/images/blank.gif" alt="" border="0"/>
        <xsl:choose>
          <xsl:when test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
            <img src="/_layouts/images/filter.gif" border="0" alt="" />
          </xsl:when>
          <xsl:otherwise>
            <img src="/_layouts/images/blank.gif" border="0" alt=""/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="not(@Filterable='FALSE') and ($sortable='FALSE')">
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Requisition</span>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
          <img src="/_layouts/images/filter.gif" border="0" alt="" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Requisition</span>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="($fieldtype='BusinessData') and not($XmlDefinition/List/@ExternalDataList='1')">
      <a style="padding-left:2px;padding-right:12px" onmouseover="" onclick="GoToLink(this);return false;"
        href="{$HttpVDir}/_layouts/BusinessDataSynchronizer.aspx?ListId={$List}&amp;ColumnName={$fieldname}">
        <img border="0" src="/_layouts/images/bdupdate.gif" alt="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}" title="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}"/>
      </a>
    </xsl:if>
  </xsl:template>
  <xsl:template name="FieldRef_header.RequisitionItem" ddwrt:dvt_mode="header" match="FieldRef[@Name='RequisitionItem']" mode="header" ddwrt:ghost="hide">
    <th nowrap="nowrap" scope="col" onmouseover="OnChildColumn(this)">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="(@Type='User' or @Type='UserMulti') and ($PresenceEnabled='1')">ms-vh</xsl:when>
          <xsl:otherwise>ms-vh2</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:call-template name="dvt_headerfield.RequisitionItem">
        <xsl:with-param name="fieldname">
          <xsl:value-of select="@Name"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtitle">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="displayname">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtype">
          <xsl:choose>
            <xsl:when test="@Type='Number' or @Type='Currency'">number</xsl:when>
            <xsl:otherwise>x:string</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </th>
  </xsl:template>
  <xsl:template name="dvt_headerfield.RequisitionItem" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:variable name="separator" select="' '" />
    <xsl:variable name="connector" select="';'" />
    <xsl:variable name="linkdir">
      <xsl:choose>
        <xsl:when test="$dvt_sortfield = $fieldname and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
        <xsl:otherwise>Asc</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="jsescapeddisplayname">
      <xsl:call-template name="fixQuotes">
        <xsl:with-param name="string" select="$displayname"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$MasterVersion=4 and not($NoAJAX)">
        <div Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
             DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
             class="ms-vh-div">
          <xsl:call-template name="headerfield.RequisitionItem">
            <xsl:with-param name="fieldname" select ="$fieldname" />
            <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
            <xsl:with-param name="displayname" select="$displayname" />
            <xsl:with-param name="fieldtype" select="$fieldtype"/>
          </xsl:call-template>
        </div>
        <xsl:if test="(not($sortable='FALSE') and not(@FieldType='MultiChoice')) or (not(@Filterable='FALSE') and not(@FieldType='Note') and not(@FieldType='URL'))">
          <div class="s4-ctx">
            <span>&#160;</span>
            <a onfocus="OnChildColumn(this.parentNode.parentNode); return false;" onclick="PopMenuFromChevron(event); return false;" href="javascript:;" title="{$open_menu}">
            </a>
            <span>&#160;</span>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="style">padding:0 !important;border:0 !important;</xsl:attribute>
        <div style="width:100%;position:relative;left:0;top:0;margin:0;border:0">
          <xsl:choose>
            <xsl:when test="$NoAJAX">
              <table CtxNum="{$ViewCounter}" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" name="{$fieldname}" DisplayName="{$displayname}" height="100%">
                <xsl:choose>
                  <xsl:when test="$MasterVersion=4">
                    <xsl:attribute name="style">width:100%;height:27px</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:attribute name="style">width:100%</xsl:attribute>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="$sortable='FALSE'">
                  <xsl:attribute name="Sortable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@Filterable='FALSE'">
                  <xsl:attribute name="Filterable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@FilterDisableMessage">
                  <xsl:attribute name="FilterDisableMessage">
                    <xsl:value-of select="@FilterDisableMessage" />
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test="not($sortable='FALSE') or not(@Filterable='FALSE')">
                  <xsl:attribute name="onmouseover">
                    <xsl:text disable-output-escaping="yes">OnMouseOverAdHocFilter(this, '</xsl:text>
                    <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
                    <xsl:text disable-output-escaping="yes">' , '', '')</xsl:text>
                  </xsl:attribute>
                  <xsl:attribute name="SortFields">
                    <xsl:value-of select="concat($RootFolderParam,$FieldSortParam,'SortField=',@Name,'&amp;SortDir=',$linkdir)"/>
                  </xsl:attribute>
                  <xsl:attribute name="FieldType">
                    <xsl:value-of select="@FieldType"/>
                  </xsl:attribute>
                  <xsl:attribute name="ResultType">
                    <xsl:value-of select="@ResultType"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:call-template name="headerFieldRow.RequisitionItem">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:when>
            <xsl:otherwise>
              <table style="width:100%;" Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
                 DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
                 height="100%" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" onmouseover="OnMouseOverFilter(this)">
                <xsl:call-template name="headerFieldRow.RequisitionItem">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </div>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="headerFieldRow.RequisitionItem" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <tr>
      <td width="100%" class="ms-vb" nowrap="nowrap">
        <xsl:if test="$MasterVersion=4 and $NoAJAX">
          <xsl:attribute name="style">padding-left:0px;padding-top:5px</xsl:attribute>
        </xsl:if>
        <xsl:call-template name="headerfield.RequisitionItem">
          <xsl:with-param name="fieldname" select ="$fieldname" />
          <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
          <xsl:with-param name="displayname" select="$displayname" />
          <xsl:with-param name="fieldtype" select="$fieldtype"/>
        </xsl:call-template>
      </td>
      <td style="position:absolute;">
        <img src="/_layouts/images/blank.gif" width="13" style="visibility: hidden" alt="" />
      </td>
    </tr>
  </xsl:template>
  <xsl:template name="headerfield.RequisitionItem" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:choose>
      <xsl:when test="$Filter='1'">
        <xsl:value-of select ="$Rows/@filter.render" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="(@ImnHeader='TRUE') and ($PresenceEnabled='1')">
            <table cellpadding="0" cellspacing="0" dir="{$XmlDefinition/List/@Direction}">
              <tr>
                <td class="ms-imnImgTD">
                  <img border="0" valign="middle" height="12" width="12" altbase="{$idPresEnabled}" src="/_layouts/images/blank.gif" onload="IMNRegisterHeader(event)" id="imnhdr{position()}"/>
                </td>
                <td nowrap="nowrap" class="ms-vh ms-imnTxtTD">
                  <xsl:call-template name="FieldHeader.RequisitionItem">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </td>
              </tr>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$fieldtype='number'">
                <div align="right" class="ms-numHeader">
                  <xsl:call-template name="FieldHeader.RequisitionItem">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </div>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="FieldHeader.RequisitionItem">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select="$fieldtype"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldHeader.RequisitionItem" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname" />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:param name="thisNode" select="."/>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="not($sortable='FALSE')">
        <xsl:variable name="sortfield">
          <xsl:choose>
            <xsl:when test="substring($fieldname, string-length($fieldname) - 5) = '(text)'">
              <xsl:value-of select="substring($fieldname, 1, string-length($fieldname) - 6)" />
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldname"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="linkdir">
          <xsl:choose>
            <xsl:when test="$dvt_sortfield = $sortfield and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
            <xsl:otherwise>Asc</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="sortText">
          <xsl:choose>
            <xsl:when test="$linkdir='Desc'">&apos; + &apos;descending&apos; + &apos;</xsl:when>
            <xsl:otherwise>&apos; + &apos;ascending&apos; + &apos;</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="jsescapeddisplayname">
          <xsl:call-template name="fixQuotes">
            <xsl:with-param name="string" select="$displayname"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="separator" select="' '" />
        <xsl:variable name="connector" select="';'" />
        <a id="diidSort{$fieldname}" onfocus="OnFocusFilter(this)">
          <xsl:attribute name="href">
            javascript: <xsl:if test="$NoAJAX">
              <xsl:call-template name="GenFireServerEvent">
                <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:attribute>
          <xsl:attribute name="onclick">
            <xsl:choose>
              <xsl:when test="not($NoAJAX)">javascript:return OnClickFilter(this,event);</xsl:when>
              <xsl:otherwise>
                javascript: <xsl:call-template name="GenFireServerEvent">
                  <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
                </xsl:call-template>; event.cancelBubble = true; return false;
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="not($NoAJAX)">
              <xsl:attribute name="SortingFields">
                <xsl:value-of select ="$RootFolderParam"/><xsl:value-of select ="$FieldSortParam"/>SortField=<xsl:value-of select="@Name"/>&amp;SortDir=<xsl:value-of select="$linkdir"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="FilterString">
                <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$fieldtype = 'Attachments'">
              <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <span>Item</span>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="$dvt_sortfield = $sortfield">
            <xsl:choose>
              <xsl:when test="$dvt_sortdir = 'ascending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortAsc}" src="{ddwrt:FieldSortImageUrl('Desc')}" />
              </xsl:when>
              <xsl:when test="$dvt_sortdir = 'descending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortDesc}" src="{ddwrt:FieldSortImageUrl('Asc')}" />
              </xsl:when>
            </xsl:choose>
          </xsl:if>
          <img src="/_layouts/images/blank.gif" class="ms-hidden" border="0" width="1" height="1" alt="{$OpenMenuKeyAccessible}"/>
        </a>
        <img src="/_layouts/images/blank.gif" alt="" border="0"/>
        <xsl:choose>
          <xsl:when test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
            <img src="/_layouts/images/filter.gif" border="0" alt="" />
          </xsl:when>
          <xsl:otherwise>
            <img src="/_layouts/images/blank.gif" border="0" alt=""/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="not(@Filterable='FALSE') and ($sortable='FALSE')">
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Item</span>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
          <img src="/_layouts/images/filter.gif" border="0" alt="" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Item</span>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="($fieldtype='BusinessData') and not($XmlDefinition/List/@ExternalDataList='1')">
      <a style="padding-left:2px;padding-right:12px" onmouseover="" onclick="GoToLink(this);return false;"
        href="{$HttpVDir}/_layouts/BusinessDataSynchronizer.aspx?ListId={$List}&amp;ColumnName={$fieldname}">
        <img border="0" src="/_layouts/images/bdupdate.gif" alt="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}" title="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}"/>
      </a>
    </xsl:if>
  </xsl:template>
  <xsl:template name="FieldRef_header.Material" ddwrt:dvt_mode="header" match="FieldRef[@Name='Material']" mode="header" ddwrt:ghost="hide">
    <th nowrap="nowrap" scope="col" onmouseover="OnChildColumn(this)">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="(@Type='User' or @Type='UserMulti') and ($PresenceEnabled='1')">ms-vh</xsl:when>
          <xsl:otherwise>ms-vh2</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:call-template name="dvt_headerfield.Material">
        <xsl:with-param name="fieldname">
          <xsl:value-of select="@Name"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtitle">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="displayname">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtype">
          <xsl:choose>
            <xsl:when test="@Type='Number' or @Type='Currency'">number</xsl:when>
            <xsl:otherwise>x:string</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </th>
  </xsl:template>
  <xsl:template name="dvt_headerfield.Material" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:variable name="separator" select="' '" />
    <xsl:variable name="connector" select="';'" />
    <xsl:variable name="linkdir">
      <xsl:choose>
        <xsl:when test="$dvt_sortfield = $fieldname and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
        <xsl:otherwise>Asc</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="jsescapeddisplayname">
      <xsl:call-template name="fixQuotes">
        <xsl:with-param name="string" select="$displayname"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$MasterVersion=4 and not($NoAJAX)">
        <div Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
             DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
             class="ms-vh-div">
          <xsl:call-template name="headerfield.Material">
            <xsl:with-param name="fieldname" select ="$fieldname" />
            <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
            <xsl:with-param name="displayname" select="$displayname" />
            <xsl:with-param name="fieldtype" select="$fieldtype"/>
          </xsl:call-template>
        </div>
        <xsl:if test="(not($sortable='FALSE') and not(@FieldType='MultiChoice')) or (not(@Filterable='FALSE') and not(@FieldType='Note') and not(@FieldType='URL'))">
          <div class="s4-ctx">
            <span>&#160;</span>
            <a onfocus="OnChildColumn(this.parentNode.parentNode); return false;" onclick="PopMenuFromChevron(event); return false;" href="javascript:;" title="{$open_menu}">
            </a>
            <span>&#160;</span>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="style">padding:0 !important;border:0 !important;</xsl:attribute>
        <div style="width:100%;position:relative;left:0;top:0;margin:0;border:0">
          <xsl:choose>
            <xsl:when test="$NoAJAX">
              <table CtxNum="{$ViewCounter}" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" name="{$fieldname}" DisplayName="{$displayname}" height="100%">
                <xsl:choose>
                  <xsl:when test="$MasterVersion=4">
                    <xsl:attribute name="style">width:100%;height:27px</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:attribute name="style">width:100%</xsl:attribute>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="$sortable='FALSE'">
                  <xsl:attribute name="Sortable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@Filterable='FALSE'">
                  <xsl:attribute name="Filterable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@FilterDisableMessage">
                  <xsl:attribute name="FilterDisableMessage">
                    <xsl:value-of select="@FilterDisableMessage" />
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test="not($sortable='FALSE') or not(@Filterable='FALSE')">
                  <xsl:attribute name="onmouseover">
                    <xsl:text disable-output-escaping="yes">OnMouseOverAdHocFilter(this, '</xsl:text>
                    <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
                    <xsl:text disable-output-escaping="yes">' , '', '')</xsl:text>
                  </xsl:attribute>
                  <xsl:attribute name="SortFields">
                    <xsl:value-of select="concat($RootFolderParam,$FieldSortParam,'SortField=',@Name,'&amp;SortDir=',$linkdir)"/>
                  </xsl:attribute>
                  <xsl:attribute name="FieldType">
                    <xsl:value-of select="@FieldType"/>
                  </xsl:attribute>
                  <xsl:attribute name="ResultType">
                    <xsl:value-of select="@ResultType"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:call-template name="headerFieldRow.Material">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:when>
            <xsl:otherwise>
              <table style="width:100%;" Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
                 DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
                 height="100%" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" onmouseover="OnMouseOverFilter(this)">
                <xsl:call-template name="headerFieldRow.Material">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </div>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="headerFieldRow.Material" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <tr>
      <td width="100%" class="ms-vb" nowrap="nowrap">
        <xsl:if test="$MasterVersion=4 and $NoAJAX">
          <xsl:attribute name="style">padding-left:0px;padding-top:5px</xsl:attribute>
        </xsl:if>
        <xsl:call-template name="headerfield.Material">
          <xsl:with-param name="fieldname" select ="$fieldname" />
          <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
          <xsl:with-param name="displayname" select="$displayname" />
          <xsl:with-param name="fieldtype" select="$fieldtype"/>
        </xsl:call-template>
      </td>
      <td style="position:absolute;">
        <img src="/_layouts/images/blank.gif" width="13" style="visibility: hidden" alt="" />
      </td>
    </tr>
  </xsl:template>
  <xsl:template name="headerfield.Material" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:choose>
      <xsl:when test="$Filter='1'">
        <xsl:value-of select ="$Rows/@filter.render" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="(@ImnHeader='TRUE') and ($PresenceEnabled='1')">
            <table cellpadding="0" cellspacing="0" dir="{$XmlDefinition/List/@Direction}">
              <tr>
                <td class="ms-imnImgTD">
                  <img border="0" valign="middle" height="12" width="12" altbase="{$idPresEnabled}" src="/_layouts/images/blank.gif" onload="IMNRegisterHeader(event)" id="imnhdr{position()}"/>
                </td>
                <td nowrap="nowrap" class="ms-vh ms-imnTxtTD">
                  <xsl:call-template name="FieldHeader.Material">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </td>
              </tr>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$fieldtype='number'">
                <div align="right" class="ms-numHeader">
                  <xsl:call-template name="FieldHeader.Material">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </div>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="FieldHeader.Material">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select="$fieldtype"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldHeader.Material" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname" />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:param name="thisNode" select="."/>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="not($sortable='FALSE')">
        <xsl:variable name="sortfield">
          <xsl:choose>
            <xsl:when test="substring($fieldname, string-length($fieldname) - 5) = '(text)'">
              <xsl:value-of select="substring($fieldname, 1, string-length($fieldname) - 6)" />
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldname"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="linkdir">
          <xsl:choose>
            <xsl:when test="$dvt_sortfield = $sortfield and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
            <xsl:otherwise>Asc</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="sortText">
          <xsl:choose>
            <xsl:when test="$linkdir='Desc'">&apos; + &apos;descending&apos; + &apos;</xsl:when>
            <xsl:otherwise>&apos; + &apos;ascending&apos; + &apos;</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="jsescapeddisplayname">
          <xsl:call-template name="fixQuotes">
            <xsl:with-param name="string" select="$displayname"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="separator" select="' '" />
        <xsl:variable name="connector" select="';'" />
        <a id="diidSort{$fieldname}" onfocus="OnFocusFilter(this)">
          <xsl:attribute name="href">
            javascript: <xsl:if test="$NoAJAX">
              <xsl:call-template name="GenFireServerEvent">
                <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:attribute>
          <xsl:attribute name="onclick">
            <xsl:choose>
              <xsl:when test="not($NoAJAX)">javascript:return OnClickFilter(this,event);</xsl:when>
              <xsl:otherwise>
                javascript: <xsl:call-template name="GenFireServerEvent">
                  <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
                </xsl:call-template>; event.cancelBubble = true; return false;
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="not($NoAJAX)">
              <xsl:attribute name="SortingFields">
                <xsl:value-of select ="$RootFolderParam"/><xsl:value-of select ="$FieldSortParam"/>SortField=<xsl:value-of select="@Name"/>&amp;SortDir=<xsl:value-of select="$linkdir"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="FilterString">
                <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$fieldtype = 'Attachments'">
              <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldtitle"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="$dvt_sortfield = $sortfield">
            <xsl:choose>
              <xsl:when test="$dvt_sortdir = 'ascending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortAsc}" src="{ddwrt:FieldSortImageUrl('Desc')}" />
              </xsl:when>
              <xsl:when test="$dvt_sortdir = 'descending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortDesc}" src="{ddwrt:FieldSortImageUrl('Asc')}" />
              </xsl:when>
            </xsl:choose>
          </xsl:if>
          <img src="/_layouts/images/blank.gif" class="ms-hidden" border="0" width="1" height="1" alt="{$OpenMenuKeyAccessible}"/>
        </a>
        <img src="/_layouts/images/blank.gif" alt="" border="0"/>
        <xsl:choose>
          <xsl:when test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
            <img src="/_layouts/images/filter.gif" border="0" alt="" />
          </xsl:when>
          <xsl:otherwise>
            <img src="/_layouts/images/blank.gif" border="0" alt=""/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="not(@Filterable='FALSE') and ($sortable='FALSE')">
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$fieldtitle"/>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
          <img src="/_layouts/images/filter.gif" border="0" alt="" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$fieldtitle"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="($fieldtype='BusinessData') and not($XmlDefinition/List/@ExternalDataList='1')">
      <a style="padding-left:2px;padding-right:12px" onmouseover="" onclick="GoToLink(this);return false;"
        href="{$HttpVDir}/_layouts/BusinessDataSynchronizer.aspx?ListId={$List}&amp;ColumnName={$fieldname}">
        <img border="0" src="/_layouts/images/bdupdate.gif" alt="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}" title="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}"/>
      </a>
    </xsl:if>
  </xsl:template>
  <xsl:template name="FieldRef_header.MaterialDescription" ddwrt:dvt_mode="header" match="FieldRef[@Name='MaterialDescription']" mode="header" ddwrt:ghost="hide">
    <th nowrap="nowrap" scope="col" onmouseover="OnChildColumn(this)">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="(@Type='User' or @Type='UserMulti') and ($PresenceEnabled='1')">ms-vh</xsl:when>
          <xsl:otherwise>ms-vh2</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:call-template name="dvt_headerfield.MaterialDescription">
        <xsl:with-param name="fieldname">
          <xsl:value-of select="@Name"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtitle">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="displayname">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtype">
          <xsl:choose>
            <xsl:when test="@Type='Number' or @Type='Currency'">number</xsl:when>
            <xsl:otherwise>x:string</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </th>
  </xsl:template>
  <xsl:template name="dvt_headerfield.MaterialDescription" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:variable name="separator" select="' '" />
    <xsl:variable name="connector" select="';'" />
    <xsl:variable name="linkdir">
      <xsl:choose>
        <xsl:when test="$dvt_sortfield = $fieldname and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
        <xsl:otherwise>Asc</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="jsescapeddisplayname">
      <xsl:call-template name="fixQuotes">
        <xsl:with-param name="string" select="$displayname"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$MasterVersion=4 and not($NoAJAX)">
        <div Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
             DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
             class="ms-vh-div">
          <xsl:call-template name="headerfield.MaterialDescription">
            <xsl:with-param name="fieldname" select ="$fieldname" />
            <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
            <xsl:with-param name="displayname" select="$displayname" />
            <xsl:with-param name="fieldtype" select="$fieldtype"/>
          </xsl:call-template>
        </div>
        <xsl:if test="(not($sortable='FALSE') and not(@FieldType='MultiChoice')) or (not(@Filterable='FALSE') and not(@FieldType='Note') and not(@FieldType='URL'))">
          <div class="s4-ctx">
            <span>&#160;</span>
            <a onfocus="OnChildColumn(this.parentNode.parentNode); return false;" onclick="PopMenuFromChevron(event); return false;" href="javascript:;" title="{$open_menu}">
            </a>
            <span>&#160;</span>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="style">padding:0 !important;border:0 !important;</xsl:attribute>
        <div style="width:100%;position:relative;left:0;top:0;margin:0;border:0">
          <xsl:choose>
            <xsl:when test="$NoAJAX">
              <table CtxNum="{$ViewCounter}" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" name="{$fieldname}" DisplayName="{$displayname}" height="100%">
                <xsl:choose>
                  <xsl:when test="$MasterVersion=4">
                    <xsl:attribute name="style">width:100%;height:27px</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:attribute name="style">width:100%</xsl:attribute>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="$sortable='FALSE'">
                  <xsl:attribute name="Sortable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@Filterable='FALSE'">
                  <xsl:attribute name="Filterable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@FilterDisableMessage">
                  <xsl:attribute name="FilterDisableMessage">
                    <xsl:value-of select="@FilterDisableMessage" />
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test="not($sortable='FALSE') or not(@Filterable='FALSE')">
                  <xsl:attribute name="onmouseover">
                    <xsl:text disable-output-escaping="yes">OnMouseOverAdHocFilter(this, '</xsl:text>
                    <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
                    <xsl:text disable-output-escaping="yes">' , '', '')</xsl:text>
                  </xsl:attribute>
                  <xsl:attribute name="SortFields">
                    <xsl:value-of select="concat($RootFolderParam,$FieldSortParam,'SortField=',@Name,'&amp;SortDir=',$linkdir)"/>
                  </xsl:attribute>
                  <xsl:attribute name="FieldType">
                    <xsl:value-of select="@FieldType"/>
                  </xsl:attribute>
                  <xsl:attribute name="ResultType">
                    <xsl:value-of select="@ResultType"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:call-template name="headerFieldRow.MaterialDescription">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:when>
            <xsl:otherwise>
              <table style="width:100%;" Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
                 DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
                 height="100%" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" onmouseover="OnMouseOverFilter(this)">
                <xsl:call-template name="headerFieldRow.MaterialDescription">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </div>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="headerFieldRow.MaterialDescription" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <tr>
      <td width="100%" class="ms-vb" nowrap="nowrap">
        <xsl:if test="$MasterVersion=4 and $NoAJAX">
          <xsl:attribute name="style">padding-left:0px;padding-top:5px</xsl:attribute>
        </xsl:if>
        <xsl:call-template name="headerfield.MaterialDescription">
          <xsl:with-param name="fieldname" select ="$fieldname" />
          <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
          <xsl:with-param name="displayname" select="$displayname" />
          <xsl:with-param name="fieldtype" select="$fieldtype"/>
        </xsl:call-template>
      </td>
      <td style="position:absolute;">
        <img src="/_layouts/images/blank.gif" width="13" style="visibility: hidden" alt="" />
      </td>
    </tr>
  </xsl:template>
  <xsl:template name="headerfield.MaterialDescription" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:choose>
      <xsl:when test="$Filter='1'">
        <xsl:value-of select ="$Rows/@filter.render" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="(@ImnHeader='TRUE') and ($PresenceEnabled='1')">
            <table cellpadding="0" cellspacing="0" dir="{$XmlDefinition/List/@Direction}">
              <tr>
                <td class="ms-imnImgTD">
                  <img border="0" valign="middle" height="12" width="12" altbase="{$idPresEnabled}" src="/_layouts/images/blank.gif" onload="IMNRegisterHeader(event)" id="imnhdr{position()}"/>
                </td>
                <td nowrap="nowrap" class="ms-vh ms-imnTxtTD">
                  <xsl:call-template name="FieldHeader.MaterialDescription">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </td>
              </tr>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$fieldtype='number'">
                <div align="right" class="ms-numHeader">
                  <xsl:call-template name="FieldHeader.MaterialDescription">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </div>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="FieldHeader.MaterialDescription">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select="$fieldtype"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldHeader.MaterialDescription" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname" />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:param name="thisNode" select="."/>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="not($sortable='FALSE')">
        <xsl:variable name="sortfield">
          <xsl:choose>
            <xsl:when test="substring($fieldname, string-length($fieldname) - 5) = '(text)'">
              <xsl:value-of select="substring($fieldname, 1, string-length($fieldname) - 6)" />
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldname"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="linkdir">
          <xsl:choose>
            <xsl:when test="$dvt_sortfield = $sortfield and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
            <xsl:otherwise>Asc</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="sortText">
          <xsl:choose>
            <xsl:when test="$linkdir='Desc'">&apos; + &apos;descending&apos; + &apos;</xsl:when>
            <xsl:otherwise>&apos; + &apos;ascending&apos; + &apos;</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="jsescapeddisplayname">
          <xsl:call-template name="fixQuotes">
            <xsl:with-param name="string" select="$displayname"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="separator" select="' '" />
        <xsl:variable name="connector" select="';'" />
        <a id="diidSort{$fieldname}" onfocus="OnFocusFilter(this)">
          <xsl:attribute name="href">
            javascript: <xsl:if test="$NoAJAX">
              <xsl:call-template name="GenFireServerEvent">
                <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:attribute>
          <xsl:attribute name="onclick">
            <xsl:choose>
              <xsl:when test="not($NoAJAX)">javascript:return OnClickFilter(this,event);</xsl:when>
              <xsl:otherwise>
                javascript: <xsl:call-template name="GenFireServerEvent">
                  <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
                </xsl:call-template>; event.cancelBubble = true; return false;
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="not($NoAJAX)">
              <xsl:attribute name="SortingFields">
                <xsl:value-of select ="$RootFolderParam"/><xsl:value-of select ="$FieldSortParam"/>SortField=<xsl:value-of select="@Name"/>&amp;SortDir=<xsl:value-of select="$linkdir"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="FilterString">
                <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$fieldtype = 'Attachments'">
              <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <span>Description</span>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="$dvt_sortfield = $sortfield">
            <xsl:choose>
              <xsl:when test="$dvt_sortdir = 'ascending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortAsc}" src="{ddwrt:FieldSortImageUrl('Desc')}" />
              </xsl:when>
              <xsl:when test="$dvt_sortdir = 'descending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortDesc}" src="{ddwrt:FieldSortImageUrl('Asc')}" />
              </xsl:when>
            </xsl:choose>
          </xsl:if>
          <img src="/_layouts/images/blank.gif" class="ms-hidden" border="0" width="1" height="1" alt="{$OpenMenuKeyAccessible}"/>
        </a>
        <img src="/_layouts/images/blank.gif" alt="" border="0"/>
        <xsl:choose>
          <xsl:when test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
            <img src="/_layouts/images/filter.gif" border="0" alt="" />
          </xsl:when>
          <xsl:otherwise>
            <img src="/_layouts/images/blank.gif" border="0" alt=""/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="not(@Filterable='FALSE') and ($sortable='FALSE')">
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Description</span>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
          <img src="/_layouts/images/filter.gif" border="0" alt="" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Description</span>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="($fieldtype='BusinessData') and not($XmlDefinition/List/@ExternalDataList='1')">
      <a style="padding-left:2px;padding-right:12px" onmouseover="" onclick="GoToLink(this);return false;"
        href="{$HttpVDir}/_layouts/BusinessDataSynchronizer.aspx?ListId={$List}&amp;ColumnName={$fieldname}">
        <img border="0" src="/_layouts/images/bdupdate.gif" alt="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}" title="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}"/>
      </a>
    </xsl:if>
  </xsl:template>
  <xsl:template name="FieldRef_header.Quantity" ddwrt:dvt_mode="header" match="FieldRef[@Name='Quantity']" mode="header" ddwrt:ghost="hide">
    <th nowrap="nowrap" scope="col" onmouseover="OnChildColumn(this)">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="(@Type='User' or @Type='UserMulti') and ($PresenceEnabled='1')">ms-vh</xsl:when>
          <xsl:otherwise>ms-vh2</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:call-template name="dvt_headerfield.Quantity">
        <xsl:with-param name="fieldname">
          <xsl:value-of select="@Name"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtitle">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="displayname">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtype">
          <xsl:choose>
            <xsl:when test="@Type='Number' or @Type='Currency'">number</xsl:when>
            <xsl:otherwise>x:string</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </th>
  </xsl:template>
  <xsl:template name="dvt_headerfield.Quantity" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:variable name="separator" select="' '" />
    <xsl:variable name="connector" select="';'" />
    <xsl:variable name="linkdir">
      <xsl:choose>
        <xsl:when test="$dvt_sortfield = $fieldname and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
        <xsl:otherwise>Asc</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="jsescapeddisplayname">
      <xsl:call-template name="fixQuotes">
        <xsl:with-param name="string" select="$displayname"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$MasterVersion=4 and not($NoAJAX)">
        <div Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
             DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
             class="ms-vh-div">
          <xsl:call-template name="headerfield.Quantity">
            <xsl:with-param name="fieldname" select ="$fieldname" />
            <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
            <xsl:with-param name="displayname" select="$displayname" />
            <xsl:with-param name="fieldtype" select="$fieldtype"/>
          </xsl:call-template>
        </div>
        <xsl:if test="(not($sortable='FALSE') and not(@FieldType='MultiChoice')) or (not(@Filterable='FALSE') and not(@FieldType='Note') and not(@FieldType='URL'))">
          <div class="s4-ctx">
            <span>&#160;</span>
            <a onfocus="OnChildColumn(this.parentNode.parentNode); return false;" onclick="PopMenuFromChevron(event); return false;" href="javascript:;" title="{$open_menu}">
            </a>
            <span>&#160;</span>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="style">padding:0 !important;border:0 !important;</xsl:attribute>
        <div style="width:100%;position:relative;left:0;top:0;margin:0;border:0">
          <xsl:choose>
            <xsl:when test="$NoAJAX">
              <table CtxNum="{$ViewCounter}" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" name="{$fieldname}" DisplayName="{$displayname}" height="100%">
                <xsl:choose>
                  <xsl:when test="$MasterVersion=4">
                    <xsl:attribute name="style">width:100%;height:27px</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:attribute name="style">width:100%</xsl:attribute>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="$sortable='FALSE'">
                  <xsl:attribute name="Sortable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@Filterable='FALSE'">
                  <xsl:attribute name="Filterable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@FilterDisableMessage">
                  <xsl:attribute name="FilterDisableMessage">
                    <xsl:value-of select="@FilterDisableMessage" />
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test="not($sortable='FALSE') or not(@Filterable='FALSE')">
                  <xsl:attribute name="onmouseover">
                    <xsl:text disable-output-escaping="yes">OnMouseOverAdHocFilter(this, '</xsl:text>
                    <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
                    <xsl:text disable-output-escaping="yes">' , '', '')</xsl:text>
                  </xsl:attribute>
                  <xsl:attribute name="SortFields">
                    <xsl:value-of select="concat($RootFolderParam,$FieldSortParam,'SortField=',@Name,'&amp;SortDir=',$linkdir)"/>
                  </xsl:attribute>
                  <xsl:attribute name="FieldType">
                    <xsl:value-of select="@FieldType"/>
                  </xsl:attribute>
                  <xsl:attribute name="ResultType">
                    <xsl:value-of select="@ResultType"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:call-template name="headerFieldRow.Quantity">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:when>
            <xsl:otherwise>
              <table style="width:100%;" Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
                 DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
                 height="100%" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" onmouseover="OnMouseOverFilter(this)">
                <xsl:call-template name="headerFieldRow.Quantity">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </div>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="headerFieldRow.Quantity" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <tr>
      <td width="100%" class="ms-vb" nowrap="nowrap">
        <xsl:if test="$MasterVersion=4 and $NoAJAX">
          <xsl:attribute name="style">padding-left:0px;padding-top:5px</xsl:attribute>
        </xsl:if>
        <xsl:call-template name="headerfield.Quantity">
          <xsl:with-param name="fieldname" select ="$fieldname" />
          <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
          <xsl:with-param name="displayname" select="$displayname" />
          <xsl:with-param name="fieldtype" select="$fieldtype"/>
        </xsl:call-template>
      </td>
      <td style="position:absolute;">
        <img src="/_layouts/images/blank.gif" width="13" style="visibility: hidden" alt="" />
      </td>
    </tr>
  </xsl:template>
  <xsl:template name="headerfield.Quantity" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:choose>
      <xsl:when test="$Filter='1'">
        <xsl:value-of select ="$Rows/@filter.render" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="(@ImnHeader='TRUE') and ($PresenceEnabled='1')">
            <table cellpadding="0" cellspacing="0" dir="{$XmlDefinition/List/@Direction}">
              <tr>
                <td class="ms-imnImgTD">
                  <img border="0" valign="middle" height="12" width="12" altbase="{$idPresEnabled}" src="/_layouts/images/blank.gif" onload="IMNRegisterHeader(event)" id="imnhdr{position()}"/>
                </td>
                <td nowrap="nowrap" class="ms-vh ms-imnTxtTD">
                  <xsl:call-template name="FieldHeader.Quantity">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </td>
              </tr>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$fieldtype='number'">
                <div align="right" class="ms-numHeader">
                  <xsl:call-template name="FieldHeader.Quantity">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </div>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="FieldHeader.Quantity">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select="$fieldtype"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldHeader.Quantity" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname" />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:param name="thisNode" select="."/>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="not($sortable='FALSE')">
        <xsl:variable name="sortfield">
          <xsl:choose>
            <xsl:when test="substring($fieldname, string-length($fieldname) - 5) = '(text)'">
              <xsl:value-of select="substring($fieldname, 1, string-length($fieldname) - 6)" />
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldname"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="linkdir">
          <xsl:choose>
            <xsl:when test="$dvt_sortfield = $sortfield and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
            <xsl:otherwise>Asc</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="sortText">
          <xsl:choose>
            <xsl:when test="$linkdir='Desc'">&apos; + &apos;descending&apos; + &apos;</xsl:when>
            <xsl:otherwise>&apos; + &apos;ascending&apos; + &apos;</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="jsescapeddisplayname">
          <xsl:call-template name="fixQuotes">
            <xsl:with-param name="string" select="$displayname"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="separator" select="' '" />
        <xsl:variable name="connector" select="';'" />
        <a id="diidSort{$fieldname}" onfocus="OnFocusFilter(this)">
          <xsl:attribute name="href">
            javascript: <xsl:if test="$NoAJAX">
              <xsl:call-template name="GenFireServerEvent">
                <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:attribute>
          <xsl:attribute name="onclick">
            <xsl:choose>
              <xsl:when test="not($NoAJAX)">javascript:return OnClickFilter(this,event);</xsl:when>
              <xsl:otherwise>
                javascript: <xsl:call-template name="GenFireServerEvent">
                  <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
                </xsl:call-template>; event.cancelBubble = true; return false;
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="not($NoAJAX)">
              <xsl:attribute name="SortingFields">
                <xsl:value-of select ="$RootFolderParam"/><xsl:value-of select ="$FieldSortParam"/>SortField=<xsl:value-of select="@Name"/>&amp;SortDir=<xsl:value-of select="$linkdir"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="FilterString">
                <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$fieldtype = 'Attachments'">
              <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <span>Qty</span>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="$dvt_sortfield = $sortfield">
            <xsl:choose>
              <xsl:when test="$dvt_sortdir = 'ascending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortAsc}" src="{ddwrt:FieldSortImageUrl('Desc')}" />
              </xsl:when>
              <xsl:when test="$dvt_sortdir = 'descending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortDesc}" src="{ddwrt:FieldSortImageUrl('Asc')}" />
              </xsl:when>
            </xsl:choose>
          </xsl:if>
          <img src="/_layouts/images/blank.gif" class="ms-hidden" border="0" width="1" height="1" alt="{$OpenMenuKeyAccessible}"/>
        </a>
        <img src="/_layouts/images/blank.gif" alt="" border="0"/>
        <xsl:choose>
          <xsl:when test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
            <img src="/_layouts/images/filter.gif" border="0" alt="" />
          </xsl:when>
          <xsl:otherwise>
            <img src="/_layouts/images/blank.gif" border="0" alt=""/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="not(@Filterable='FALSE') and ($sortable='FALSE')">
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Qty</span>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
          <img src="/_layouts/images/filter.gif" border="0" alt="" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Qty</span>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="($fieldtype='BusinessData') and not($XmlDefinition/List/@ExternalDataList='1')">
      <a style="padding-left:2px;padding-right:12px" onmouseover="" onclick="GoToLink(this);return false;"
        href="{$HttpVDir}/_layouts/BusinessDataSynchronizer.aspx?ListId={$List}&amp;ColumnName={$fieldname}">
        <img border="0" src="/_layouts/images/bdupdate.gif" alt="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}" title="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}"/>
      </a>
    </xsl:if>
  </xsl:template>
  <xsl:template name="FieldRef_header.Unit" ddwrt:dvt_mode="header" match="FieldRef[@Name='Unit']" mode="header" ddwrt:ghost="hide">
    <th nowrap="nowrap" scope="col" onmouseover="OnChildColumn(this)">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="(@Type='User' or @Type='UserMulti') and ($PresenceEnabled='1')">ms-vh</xsl:when>
          <xsl:otherwise>ms-vh2</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:call-template name="dvt_headerfield.Unit">
        <xsl:with-param name="fieldname">
          <xsl:value-of select="@Name"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtitle">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="displayname">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtype">
          <xsl:choose>
            <xsl:when test="@Type='Number' or @Type='Currency'">number</xsl:when>
            <xsl:otherwise>x:string</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </th>
  </xsl:template>
  <xsl:template name="dvt_headerfield.Unit" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:variable name="separator" select="' '" />
    <xsl:variable name="connector" select="';'" />
    <xsl:variable name="linkdir">
      <xsl:choose>
        <xsl:when test="$dvt_sortfield = $fieldname and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
        <xsl:otherwise>Asc</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="jsescapeddisplayname">
      <xsl:call-template name="fixQuotes">
        <xsl:with-param name="string" select="$displayname"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$MasterVersion=4 and not($NoAJAX)">
        <div Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
             DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
             class="ms-vh-div">
          <xsl:call-template name="headerfield.Unit">
            <xsl:with-param name="fieldname" select ="$fieldname" />
            <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
            <xsl:with-param name="displayname" select="$displayname" />
            <xsl:with-param name="fieldtype" select="$fieldtype"/>
          </xsl:call-template>
        </div>
        <xsl:if test="(not($sortable='FALSE') and not(@FieldType='MultiChoice')) or (not(@Filterable='FALSE') and not(@FieldType='Note') and not(@FieldType='URL'))">
          <div class="s4-ctx">
            <span>&#160;</span>
            <a onfocus="OnChildColumn(this.parentNode.parentNode); return false;" onclick="PopMenuFromChevron(event); return false;" href="javascript:;" title="{$open_menu}">
            </a>
            <span>&#160;</span>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="style">padding:0 !important;border:0 !important;</xsl:attribute>
        <div style="width:100%;position:relative;left:0;top:0;margin:0;border:0">
          <xsl:choose>
            <xsl:when test="$NoAJAX">
              <table CtxNum="{$ViewCounter}" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" name="{$fieldname}" DisplayName="{$displayname}" height="100%">
                <xsl:choose>
                  <xsl:when test="$MasterVersion=4">
                    <xsl:attribute name="style">width:100%;height:27px</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:attribute name="style">width:100%</xsl:attribute>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="$sortable='FALSE'">
                  <xsl:attribute name="Sortable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@Filterable='FALSE'">
                  <xsl:attribute name="Filterable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@FilterDisableMessage">
                  <xsl:attribute name="FilterDisableMessage">
                    <xsl:value-of select="@FilterDisableMessage" />
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test="not($sortable='FALSE') or not(@Filterable='FALSE')">
                  <xsl:attribute name="onmouseover">
                    <xsl:text disable-output-escaping="yes">OnMouseOverAdHocFilter(this, '</xsl:text>
                    <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
                    <xsl:text disable-output-escaping="yes">' , '', '')</xsl:text>
                  </xsl:attribute>
                  <xsl:attribute name="SortFields">
                    <xsl:value-of select="concat($RootFolderParam,$FieldSortParam,'SortField=',@Name,'&amp;SortDir=',$linkdir)"/>
                  </xsl:attribute>
                  <xsl:attribute name="FieldType">
                    <xsl:value-of select="@FieldType"/>
                  </xsl:attribute>
                  <xsl:attribute name="ResultType">
                    <xsl:value-of select="@ResultType"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:call-template name="headerFieldRow.Unit">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:when>
            <xsl:otherwise>
              <table style="width:100%;" Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
                 DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
                 height="100%" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" onmouseover="OnMouseOverFilter(this)">
                <xsl:call-template name="headerFieldRow.Unit">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </div>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="headerFieldRow.Unit" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <tr>
      <td width="100%" class="ms-vb" nowrap="nowrap">
        <xsl:if test="$MasterVersion=4 and $NoAJAX">
          <xsl:attribute name="style">padding-left:0px;padding-top:5px</xsl:attribute>
        </xsl:if>
        <xsl:call-template name="headerfield.Unit">
          <xsl:with-param name="fieldname" select ="$fieldname" />
          <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
          <xsl:with-param name="displayname" select="$displayname" />
          <xsl:with-param name="fieldtype" select="$fieldtype"/>
        </xsl:call-template>
      </td>
      <td style="position:absolute;">
        <img src="/_layouts/images/blank.gif" width="13" style="visibility: hidden" alt="" />
      </td>
    </tr>
  </xsl:template>
  <xsl:template name="headerfield.Unit" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:choose>
      <xsl:when test="$Filter='1'">
        <xsl:value-of select ="$Rows/@filter.render" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="(@ImnHeader='TRUE') and ($PresenceEnabled='1')">
            <table cellpadding="0" cellspacing="0" dir="{$XmlDefinition/List/@Direction}">
              <tr>
                <td class="ms-imnImgTD">
                  <img border="0" valign="middle" height="12" width="12" altbase="{$idPresEnabled}" src="/_layouts/images/blank.gif" onload="IMNRegisterHeader(event)" id="imnhdr{position()}"/>
                </td>
                <td nowrap="nowrap" class="ms-vh ms-imnTxtTD">
                  <xsl:call-template name="FieldHeader.Unit">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </td>
              </tr>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$fieldtype='number'">
                <div align="right" class="ms-numHeader">
                  <xsl:call-template name="FieldHeader.Unit">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </div>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="FieldHeader.Unit">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select="$fieldtype"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldHeader.Unit" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname" />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:param name="thisNode" select="."/>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="not($sortable='FALSE')">
        <xsl:variable name="sortfield">
          <xsl:choose>
            <xsl:when test="substring($fieldname, string-length($fieldname) - 5) = '(text)'">
              <xsl:value-of select="substring($fieldname, 1, string-length($fieldname) - 6)" />
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldname"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="linkdir">
          <xsl:choose>
            <xsl:when test="$dvt_sortfield = $sortfield and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
            <xsl:otherwise>Asc</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="sortText">
          <xsl:choose>
            <xsl:when test="$linkdir='Desc'">&apos; + &apos;descending&apos; + &apos;</xsl:when>
            <xsl:otherwise>&apos; + &apos;ascending&apos; + &apos;</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="jsescapeddisplayname">
          <xsl:call-template name="fixQuotes">
            <xsl:with-param name="string" select="$displayname"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="separator" select="' '" />
        <xsl:variable name="connector" select="';'" />
        <a id="diidSort{$fieldname}" onfocus="OnFocusFilter(this)">
          <xsl:attribute name="href">
            javascript: <xsl:if test="$NoAJAX">
              <xsl:call-template name="GenFireServerEvent">
                <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:attribute>
          <xsl:attribute name="onclick">
            <xsl:choose>
              <xsl:when test="not($NoAJAX)">javascript:return OnClickFilter(this,event);</xsl:when>
              <xsl:otherwise>
                javascript: <xsl:call-template name="GenFireServerEvent">
                  <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
                </xsl:call-template>; event.cancelBubble = true; return false;
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="not($NoAJAX)">
              <xsl:attribute name="SortingFields">
                <xsl:value-of select ="$RootFolderParam"/><xsl:value-of select ="$FieldSortParam"/>SortField=<xsl:value-of select="@Name"/>&amp;SortDir=<xsl:value-of select="$linkdir"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="FilterString">
                <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$fieldtype = 'Attachments'">
              <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <span> </span>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="$dvt_sortfield = $sortfield">
            <xsl:choose>
              <xsl:when test="$dvt_sortdir = 'ascending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortAsc}" src="{ddwrt:FieldSortImageUrl('Desc')}" />
              </xsl:when>
              <xsl:when test="$dvt_sortdir = 'descending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortDesc}" src="{ddwrt:FieldSortImageUrl('Asc')}" />
              </xsl:when>
            </xsl:choose>
          </xsl:if>
          <img src="/_layouts/images/blank.gif" class="ms-hidden" border="0" width="1" height="1" alt="{$OpenMenuKeyAccessible}"/>
        </a>
        <img src="/_layouts/images/blank.gif" alt="" border="0"/>
        <xsl:choose>
          <xsl:when test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
            <img src="/_layouts/images/filter.gif" border="0" alt="" />
          </xsl:when>
          <xsl:otherwise>
            <img src="/_layouts/images/blank.gif" border="0" alt=""/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="not(@Filterable='FALSE') and ($sortable='FALSE')">
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span> </span>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
          <img src="/_layouts/images/filter.gif" border="0" alt="" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span> </span>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="($fieldtype='BusinessData') and not($XmlDefinition/List/@ExternalDataList='1')">
      <a style="padding-left:2px;padding-right:12px" onmouseover="" onclick="GoToLink(this);return false;"
        href="{$HttpVDir}/_layouts/BusinessDataSynchronizer.aspx?ListId={$List}&amp;ColumnName={$fieldname}">
        <img border="0" src="/_layouts/images/bdupdate.gif" alt="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}" title="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}"/>
      </a>
    </xsl:if>
  </xsl:template>
  <xsl:template name="FieldRef_header.Amount" ddwrt:dvt_mode="header" match="FieldRef[@Name='Amount']" mode="header" ddwrt:ghost="hide">
    <th nowrap="nowrap" scope="col" onmouseover="OnChildColumn(this)">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="(@Type='User' or @Type='UserMulti') and ($PresenceEnabled='1')">ms-vh</xsl:when>
          <xsl:otherwise>ms-vh2</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:call-template name="dvt_headerfield.Amount">
        <xsl:with-param name="fieldname">
          <xsl:value-of select="@Name"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtitle">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="displayname">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtype">
          <xsl:choose>
            <xsl:when test="@Type='Number' or @Type='Currency'">number</xsl:when>
            <xsl:otherwise>x:string</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </th>
  </xsl:template>
  <xsl:template name="dvt_headerfield.Amount" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:variable name="separator" select="' '" />
    <xsl:variable name="connector" select="';'" />
    <xsl:variable name="linkdir">
      <xsl:choose>
        <xsl:when test="$dvt_sortfield = $fieldname and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
        <xsl:otherwise>Asc</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="jsescapeddisplayname">
      <xsl:call-template name="fixQuotes">
        <xsl:with-param name="string" select="$displayname"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$MasterVersion=4 and not($NoAJAX)">
        <div Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
             DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
             class="ms-vh-div">
          <xsl:call-template name="headerfield.Amount">
            <xsl:with-param name="fieldname" select ="$fieldname" />
            <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
            <xsl:with-param name="displayname" select="$displayname" />
            <xsl:with-param name="fieldtype" select="$fieldtype"/>
          </xsl:call-template>
        </div>
        <xsl:if test="(not($sortable='FALSE') and not(@FieldType='MultiChoice')) or (not(@Filterable='FALSE') and not(@FieldType='Note') and not(@FieldType='URL'))">
          <div class="s4-ctx">
            <span>&#160;</span>
            <a onfocus="OnChildColumn(this.parentNode.parentNode); return false;" onclick="PopMenuFromChevron(event); return false;" href="javascript:;" title="{$open_menu}">
            </a>
            <span>&#160;</span>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="style">padding:0 !important;border:0 !important;</xsl:attribute>
        <div style="width:100%;position:relative;left:0;top:0;margin:0;border:0">
          <xsl:choose>
            <xsl:when test="$NoAJAX">
              <table CtxNum="{$ViewCounter}" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" name="{$fieldname}" DisplayName="{$displayname}" height="100%">
                <xsl:choose>
                  <xsl:when test="$MasterVersion=4">
                    <xsl:attribute name="style">width:100%;height:27px</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:attribute name="style">width:100%</xsl:attribute>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="$sortable='FALSE'">
                  <xsl:attribute name="Sortable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@Filterable='FALSE'">
                  <xsl:attribute name="Filterable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@FilterDisableMessage">
                  <xsl:attribute name="FilterDisableMessage">
                    <xsl:value-of select="@FilterDisableMessage" />
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test="not($sortable='FALSE') or not(@Filterable='FALSE')">
                  <xsl:attribute name="onmouseover">
                    <xsl:text disable-output-escaping="yes">OnMouseOverAdHocFilter(this, '</xsl:text>
                    <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
                    <xsl:text disable-output-escaping="yes">' , '', '')</xsl:text>
                  </xsl:attribute>
                  <xsl:attribute name="SortFields">
                    <xsl:value-of select="concat($RootFolderParam,$FieldSortParam,'SortField=',@Name,'&amp;SortDir=',$linkdir)"/>
                  </xsl:attribute>
                  <xsl:attribute name="FieldType">
                    <xsl:value-of select="@FieldType"/>
                  </xsl:attribute>
                  <xsl:attribute name="ResultType">
                    <xsl:value-of select="@ResultType"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:call-template name="headerFieldRow.Amount">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:when>
            <xsl:otherwise>
              <table style="width:100%;" Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
                 DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
                 height="100%" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" onmouseover="OnMouseOverFilter(this)">
                <xsl:call-template name="headerFieldRow.Amount">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </div>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="headerFieldRow.Amount" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <tr>
      <td width="100%" class="ms-vb" nowrap="nowrap">
        <xsl:if test="$MasterVersion=4 and $NoAJAX">
          <xsl:attribute name="style">padding-left:0px;padding-top:5px</xsl:attribute>
        </xsl:if>
        <xsl:call-template name="headerfield.Amount">
          <xsl:with-param name="fieldname" select ="$fieldname" />
          <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
          <xsl:with-param name="displayname" select="$displayname" />
          <xsl:with-param name="fieldtype" select="$fieldtype"/>
        </xsl:call-template>
      </td>
      <td style="position:absolute;">
        <img src="/_layouts/images/blank.gif" width="13" style="visibility: hidden" alt="" />
      </td>
    </tr>
  </xsl:template>
  <xsl:template name="headerfield.Amount" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:choose>
      <xsl:when test="$Filter='1'">
        <xsl:value-of select ="$Rows/@filter.render" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="(@ImnHeader='TRUE') and ($PresenceEnabled='1')">
            <table cellpadding="0" cellspacing="0" dir="{$XmlDefinition/List/@Direction}">
              <tr>
                <td class="ms-imnImgTD">
                  <img border="0" valign="middle" height="12" width="12" altbase="{$idPresEnabled}" src="/_layouts/images/blank.gif" onload="IMNRegisterHeader(event)" id="imnhdr{position()}"/>
                </td>
                <td nowrap="nowrap" class="ms-vh ms-imnTxtTD">
                  <xsl:call-template name="FieldHeader.Amount">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </td>
              </tr>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$fieldtype='number'">
                <div align="right" class="ms-numHeader">
                  <xsl:call-template name="FieldHeader.Amount">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </div>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="FieldHeader.Amount">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select="$fieldtype"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldHeader.Amount" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname" />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:param name="thisNode" select="."/>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="not($sortable='FALSE')">
        <xsl:variable name="sortfield">
          <xsl:choose>
            <xsl:when test="substring($fieldname, string-length($fieldname) - 5) = '(text)'">
              <xsl:value-of select="substring($fieldname, 1, string-length($fieldname) - 6)" />
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldname"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="linkdir">
          <xsl:choose>
            <xsl:when test="$dvt_sortfield = $sortfield and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
            <xsl:otherwise>Asc</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="sortText">
          <xsl:choose>
            <xsl:when test="$linkdir='Desc'">&apos; + &apos;descending&apos; + &apos;</xsl:when>
            <xsl:otherwise>&apos; + &apos;ascending&apos; + &apos;</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="jsescapeddisplayname">
          <xsl:call-template name="fixQuotes">
            <xsl:with-param name="string" select="$displayname"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="separator" select="' '" />
        <xsl:variable name="connector" select="';'" />
        <a id="diidSort{$fieldname}" onfocus="OnFocusFilter(this)">
          <xsl:attribute name="href">
            javascript: <xsl:if test="$NoAJAX">
              <xsl:call-template name="GenFireServerEvent">
                <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:attribute>
          <xsl:attribute name="onclick">
            <xsl:choose>
              <xsl:when test="not($NoAJAX)">javascript:return OnClickFilter(this,event);</xsl:when>
              <xsl:otherwise>
                javascript: <xsl:call-template name="GenFireServerEvent">
                  <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
                </xsl:call-template>; event.cancelBubble = true; return false;
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="not($NoAJAX)">
              <xsl:attribute name="SortingFields">
                <xsl:value-of select ="$RootFolderParam"/><xsl:value-of select ="$FieldSortParam"/>SortField=<xsl:value-of select="@Name"/>&amp;SortDir=<xsl:value-of select="$linkdir"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="FilterString">
                <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$fieldtype = 'Attachments'">
              <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldtitle"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="$dvt_sortfield = $sortfield">
            <xsl:choose>
              <xsl:when test="$dvt_sortdir = 'ascending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortAsc}" src="{ddwrt:FieldSortImageUrl('Desc')}" />
              </xsl:when>
              <xsl:when test="$dvt_sortdir = 'descending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortDesc}" src="{ddwrt:FieldSortImageUrl('Asc')}" />
              </xsl:when>
            </xsl:choose>
          </xsl:if>
          <img src="/_layouts/images/blank.gif" class="ms-hidden" border="0" width="1" height="1" alt="{$OpenMenuKeyAccessible}"/>
        </a>
        <img src="/_layouts/images/blank.gif" alt="" border="0"/>
        <xsl:choose>
          <xsl:when test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
            <img src="/_layouts/images/filter.gif" border="0" alt="" />
          </xsl:when>
          <xsl:otherwise>
            <img src="/_layouts/images/blank.gif" border="0" alt=""/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="not(@Filterable='FALSE') and ($sortable='FALSE')">
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$fieldtitle"/>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
          <img src="/_layouts/images/filter.gif" border="0" alt="" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$fieldtitle"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="($fieldtype='BusinessData') and not($XmlDefinition/List/@ExternalDataList='1')">
      <a style="padding-left:2px;padding-right:12px" onmouseover="" onclick="GoToLink(this);return false;"
        href="{$HttpVDir}/_layouts/BusinessDataSynchronizer.aspx?ListId={$List}&amp;ColumnName={$fieldname}">
        <img border="0" src="/_layouts/images/bdupdate.gif" alt="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}" title="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}"/>
      </a>
    </xsl:if>
  </xsl:template>
  <xsl:template name="FieldRef_header.Currency" ddwrt:dvt_mode="header" match="FieldRef[@Name='Currency']" mode="header" ddwrt:ghost="hide">
    <th nowrap="nowrap" scope="col" onmouseover="OnChildColumn(this)">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="(@Type='User' or @Type='UserMulti') and ($PresenceEnabled='1')">ms-vh</xsl:when>
          <xsl:otherwise>ms-vh2</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:call-template name="dvt_headerfield.Currency">
        <xsl:with-param name="fieldname">
          <xsl:value-of select="@Name"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtitle">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="displayname">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtype">
          <xsl:choose>
            <xsl:when test="@Type='Number' or @Type='Currency'">number</xsl:when>
            <xsl:otherwise>x:string</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </th>
  </xsl:template>
  <xsl:template name="dvt_headerfield.Currency" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:variable name="separator" select="' '" />
    <xsl:variable name="connector" select="';'" />
    <xsl:variable name="linkdir">
      <xsl:choose>
        <xsl:when test="$dvt_sortfield = $fieldname and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
        <xsl:otherwise>Asc</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="jsescapeddisplayname">
      <xsl:call-template name="fixQuotes">
        <xsl:with-param name="string" select="$displayname"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$MasterVersion=4 and not($NoAJAX)">
        <div Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
             DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
             class="ms-vh-div">
          <xsl:call-template name="headerfield.Currency">
            <xsl:with-param name="fieldname" select ="$fieldname" />
            <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
            <xsl:with-param name="displayname" select="$displayname" />
            <xsl:with-param name="fieldtype" select="$fieldtype"/>
          </xsl:call-template>
        </div>
        <xsl:if test="(not($sortable='FALSE') and not(@FieldType='MultiChoice')) or (not(@Filterable='FALSE') and not(@FieldType='Note') and not(@FieldType='URL'))">
          <div class="s4-ctx">
            <span>&#160;</span>
            <a onfocus="OnChildColumn(this.parentNode.parentNode); return false;" onclick="PopMenuFromChevron(event); return false;" href="javascript:;" title="{$open_menu}">
            </a>
            <span>&#160;</span>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="style">padding:0 !important;border:0 !important;</xsl:attribute>
        <div style="width:100%;position:relative;left:0;top:0;margin:0;border:0">
          <xsl:choose>
            <xsl:when test="$NoAJAX">
              <table CtxNum="{$ViewCounter}" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" name="{$fieldname}" DisplayName="{$displayname}" height="100%">
                <xsl:choose>
                  <xsl:when test="$MasterVersion=4">
                    <xsl:attribute name="style">width:100%;height:27px</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:attribute name="style">width:100%</xsl:attribute>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="$sortable='FALSE'">
                  <xsl:attribute name="Sortable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@Filterable='FALSE'">
                  <xsl:attribute name="Filterable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@FilterDisableMessage">
                  <xsl:attribute name="FilterDisableMessage">
                    <xsl:value-of select="@FilterDisableMessage" />
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test="not($sortable='FALSE') or not(@Filterable='FALSE')">
                  <xsl:attribute name="onmouseover">
                    <xsl:text disable-output-escaping="yes">OnMouseOverAdHocFilter(this, '</xsl:text>
                    <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
                    <xsl:text disable-output-escaping="yes">' , '', '')</xsl:text>
                  </xsl:attribute>
                  <xsl:attribute name="SortFields">
                    <xsl:value-of select="concat($RootFolderParam,$FieldSortParam,'SortField=',@Name,'&amp;SortDir=',$linkdir)"/>
                  </xsl:attribute>
                  <xsl:attribute name="FieldType">
                    <xsl:value-of select="@FieldType"/>
                  </xsl:attribute>
                  <xsl:attribute name="ResultType">
                    <xsl:value-of select="@ResultType"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:call-template name="headerFieldRow.Currency">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:when>
            <xsl:otherwise>
              <table style="width:100%;" Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
                 DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
                 height="100%" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" onmouseover="OnMouseOverFilter(this)">
                <xsl:call-template name="headerFieldRow.Currency">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </div>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="headerFieldRow.Currency" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <tr>
      <td width="100%" class="ms-vb" nowrap="nowrap">
        <xsl:if test="$MasterVersion=4 and $NoAJAX">
          <xsl:attribute name="style">padding-left:0px;padding-top:5px</xsl:attribute>
        </xsl:if>
        <xsl:call-template name="headerfield.Currency">
          <xsl:with-param name="fieldname" select ="$fieldname" />
          <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
          <xsl:with-param name="displayname" select="$displayname" />
          <xsl:with-param name="fieldtype" select="$fieldtype"/>
        </xsl:call-template>
      </td>
      <td style="position:absolute;">
        <img src="/_layouts/images/blank.gif" width="13" style="visibility: hidden" alt="" />
      </td>
    </tr>
  </xsl:template>
  <xsl:template name="headerfield.Currency" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:choose>
      <xsl:when test="$Filter='1'">
        <xsl:value-of select ="$Rows/@filter.render" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="(@ImnHeader='TRUE') and ($PresenceEnabled='1')">
            <table cellpadding="0" cellspacing="0" dir="{$XmlDefinition/List/@Direction}">
              <tr>
                <td class="ms-imnImgTD">
                  <img border="0" valign="middle" height="12" width="12" altbase="{$idPresEnabled}" src="/_layouts/images/blank.gif" onload="IMNRegisterHeader(event)" id="imnhdr{position()}"/>
                </td>
                <td nowrap="nowrap" class="ms-vh ms-imnTxtTD">
                  <xsl:call-template name="FieldHeader.Currency">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </td>
              </tr>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$fieldtype='number'">
                <div align="right" class="ms-numHeader">
                  <xsl:call-template name="FieldHeader.Currency">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </div>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="FieldHeader.Currency">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select="$fieldtype"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldHeader.Currency" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname" />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:param name="thisNode" select="."/>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="not($sortable='FALSE')">
        <xsl:variable name="sortfield">
          <xsl:choose>
            <xsl:when test="substring($fieldname, string-length($fieldname) - 5) = '(text)'">
              <xsl:value-of select="substring($fieldname, 1, string-length($fieldname) - 6)" />
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldname"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="linkdir">
          <xsl:choose>
            <xsl:when test="$dvt_sortfield = $sortfield and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
            <xsl:otherwise>Asc</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="sortText">
          <xsl:choose>
            <xsl:when test="$linkdir='Desc'">&apos; + &apos;descending&apos; + &apos;</xsl:when>
            <xsl:otherwise>&apos; + &apos;ascending&apos; + &apos;</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="jsescapeddisplayname">
          <xsl:call-template name="fixQuotes">
            <xsl:with-param name="string" select="$displayname"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="separator" select="' '" />
        <xsl:variable name="connector" select="';'" />
        <a id="diidSort{$fieldname}" onfocus="OnFocusFilter(this)">
          <xsl:attribute name="href">
            javascript: <xsl:if test="$NoAJAX">
              <xsl:call-template name="GenFireServerEvent">
                <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:attribute>
          <xsl:attribute name="onclick">
            <xsl:choose>
              <xsl:when test="not($NoAJAX)">javascript:return OnClickFilter(this,event);</xsl:when>
              <xsl:otherwise>
                javascript: <xsl:call-template name="GenFireServerEvent">
                  <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
                </xsl:call-template>; event.cancelBubble = true; return false;
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="not($NoAJAX)">
              <xsl:attribute name="SortingFields">
                <xsl:value-of select ="$RootFolderParam"/><xsl:value-of select ="$FieldSortParam"/>SortField=<xsl:value-of select="@Name"/>&amp;SortDir=<xsl:value-of select="$linkdir"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="FilterString">
                <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$fieldtype = 'Attachments'">
              <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <span> </span>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="$dvt_sortfield = $sortfield">
            <xsl:choose>
              <xsl:when test="$dvt_sortdir = 'ascending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortAsc}" src="{ddwrt:FieldSortImageUrl('Desc')}" />
              </xsl:when>
              <xsl:when test="$dvt_sortdir = 'descending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortDesc}" src="{ddwrt:FieldSortImageUrl('Asc')}" />
              </xsl:when>
            </xsl:choose>
          </xsl:if>
          <img src="/_layouts/images/blank.gif" class="ms-hidden" border="0" width="1" height="1" alt="{$OpenMenuKeyAccessible}"/>
        </a>
        <img src="/_layouts/images/blank.gif" alt="" border="0"/>
        <xsl:choose>
          <xsl:when test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
            <img src="/_layouts/images/filter.gif" border="0" alt="" />
          </xsl:when>
          <xsl:otherwise>
            <img src="/_layouts/images/blank.gif" border="0" alt=""/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="not(@Filterable='FALSE') and ($sortable='FALSE')">
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span> </span>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
          <img src="/_layouts/images/filter.gif" border="0" alt="" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span> </span>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="($fieldtype='BusinessData') and not($XmlDefinition/List/@ExternalDataList='1')">
      <a style="padding-left:2px;padding-right:12px" onmouseover="" onclick="GoToLink(this);return false;"
        href="{$HttpVDir}/_layouts/BusinessDataSynchronizer.aspx?ListId={$List}&amp;ColumnName={$fieldname}">
        <img border="0" src="/_layouts/images/bdupdate.gif" alt="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}" title="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}"/>
      </a>
    </xsl:if>
  </xsl:template>
  <xsl:template name="FieldRef_header.DeliveryDate" ddwrt:dvt_mode="header" match="FieldRef[@Name='DeliveryDate']" mode="header" ddwrt:ghost="hide">
    <th nowrap="nowrap" scope="col" onmouseover="OnChildColumn(this)">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="(@Type='User' or @Type='UserMulti') and ($PresenceEnabled='1')">ms-vh</xsl:when>
          <xsl:otherwise>ms-vh2</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:call-template name="dvt_headerfield.DeliveryDate">
        <xsl:with-param name="fieldname">
          <xsl:value-of select="@Name"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtitle">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="displayname">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtype">
          <xsl:choose>
            <xsl:when test="@Type='Number' or @Type='Currency'">number</xsl:when>
            <xsl:otherwise>x:string</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </th>
  </xsl:template>
  <xsl:template name="dvt_headerfield.DeliveryDate" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:variable name="separator" select="' '" />
    <xsl:variable name="connector" select="';'" />
    <xsl:variable name="linkdir">
      <xsl:choose>
        <xsl:when test="$dvt_sortfield = $fieldname and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
        <xsl:otherwise>Asc</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="jsescapeddisplayname">
      <xsl:call-template name="fixQuotes">
        <xsl:with-param name="string" select="$displayname"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$MasterVersion=4 and not($NoAJAX)">
        <div Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
             DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
             class="ms-vh-div">
          <xsl:call-template name="headerfield.DeliveryDate">
            <xsl:with-param name="fieldname" select ="$fieldname" />
            <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
            <xsl:with-param name="displayname" select="$displayname" />
            <xsl:with-param name="fieldtype" select="$fieldtype"/>
          </xsl:call-template>
        </div>
        <xsl:if test="(not($sortable='FALSE') and not(@FieldType='MultiChoice')) or (not(@Filterable='FALSE') and not(@FieldType='Note') and not(@FieldType='URL'))">
          <div class="s4-ctx">
            <span>&#160;</span>
            <a onfocus="OnChildColumn(this.parentNode.parentNode); return false;" onclick="PopMenuFromChevron(event); return false;" href="javascript:;" title="{$open_menu}">
            </a>
            <span>&#160;</span>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="style">padding:0 !important;border:0 !important;</xsl:attribute>
        <div style="width:100%;position:relative;left:0;top:0;margin:0;border:0">
          <xsl:choose>
            <xsl:when test="$NoAJAX">
              <table CtxNum="{$ViewCounter}" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" name="{$fieldname}" DisplayName="{$displayname}" height="100%">
                <xsl:choose>
                  <xsl:when test="$MasterVersion=4">
                    <xsl:attribute name="style">width:100%;height:27px</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:attribute name="style">width:100%</xsl:attribute>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="$sortable='FALSE'">
                  <xsl:attribute name="Sortable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@Filterable='FALSE'">
                  <xsl:attribute name="Filterable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@FilterDisableMessage">
                  <xsl:attribute name="FilterDisableMessage">
                    <xsl:value-of select="@FilterDisableMessage" />
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test="not($sortable='FALSE') or not(@Filterable='FALSE')">
                  <xsl:attribute name="onmouseover">
                    <xsl:text disable-output-escaping="yes">OnMouseOverAdHocFilter(this, '</xsl:text>
                    <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
                    <xsl:text disable-output-escaping="yes">' , '', '')</xsl:text>
                  </xsl:attribute>
                  <xsl:attribute name="SortFields">
                    <xsl:value-of select="concat($RootFolderParam,$FieldSortParam,'SortField=',@Name,'&amp;SortDir=',$linkdir)"/>
                  </xsl:attribute>
                  <xsl:attribute name="FieldType">
                    <xsl:value-of select="@FieldType"/>
                  </xsl:attribute>
                  <xsl:attribute name="ResultType">
                    <xsl:value-of select="@ResultType"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:call-template name="headerFieldRow.DeliveryDate">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:when>
            <xsl:otherwise>
              <table style="width:100%;" Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
                 DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
                 height="100%" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" onmouseover="OnMouseOverFilter(this)">
                <xsl:call-template name="headerFieldRow.DeliveryDate">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </div>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="headerFieldRow.DeliveryDate" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <tr>
      <td width="100%" class="ms-vb" nowrap="nowrap">
        <xsl:if test="$MasterVersion=4 and $NoAJAX">
          <xsl:attribute name="style">padding-left:0px;padding-top:5px</xsl:attribute>
        </xsl:if>
        <xsl:call-template name="headerfield.DeliveryDate">
          <xsl:with-param name="fieldname" select ="$fieldname" />
          <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
          <xsl:with-param name="displayname" select="$displayname" />
          <xsl:with-param name="fieldtype" select="$fieldtype"/>
        </xsl:call-template>
      </td>
      <td style="position:absolute;">
        <img src="/_layouts/images/blank.gif" width="13" style="visibility: hidden" alt="" />
      </td>
    </tr>
  </xsl:template>
  <xsl:template name="headerfield.DeliveryDate" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:choose>
      <xsl:when test="$Filter='1'">
        <xsl:value-of select ="$Rows/@filter.render" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="(@ImnHeader='TRUE') and ($PresenceEnabled='1')">
            <table cellpadding="0" cellspacing="0" dir="{$XmlDefinition/List/@Direction}">
              <tr>
                <td class="ms-imnImgTD">
                  <img border="0" valign="middle" height="12" width="12" altbase="{$idPresEnabled}" src="/_layouts/images/blank.gif" onload="IMNRegisterHeader(event)" id="imnhdr{position()}"/>
                </td>
                <td nowrap="nowrap" class="ms-vh ms-imnTxtTD">
                  <xsl:call-template name="FieldHeader.DeliveryDate">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </td>
              </tr>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$fieldtype='number'">
                <div align="right" class="ms-numHeader">
                  <xsl:call-template name="FieldHeader.DeliveryDate">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </div>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="FieldHeader.DeliveryDate">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select="$fieldtype"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldHeader.DeliveryDate" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname" />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:param name="thisNode" select="."/>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="not($sortable='FALSE')">
        <xsl:variable name="sortfield">
          <xsl:choose>
            <xsl:when test="substring($fieldname, string-length($fieldname) - 5) = '(text)'">
              <xsl:value-of select="substring($fieldname, 1, string-length($fieldname) - 6)" />
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldname"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="linkdir">
          <xsl:choose>
            <xsl:when test="$dvt_sortfield = $sortfield and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
            <xsl:otherwise>Asc</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="sortText">
          <xsl:choose>
            <xsl:when test="$linkdir='Desc'">&apos; + &apos;descending&apos; + &apos;</xsl:when>
            <xsl:otherwise>&apos; + &apos;ascending&apos; + &apos;</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="jsescapeddisplayname">
          <xsl:call-template name="fixQuotes">
            <xsl:with-param name="string" select="$displayname"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="separator" select="' '" />
        <xsl:variable name="connector" select="';'" />
        <a id="diidSort{$fieldname}" onfocus="OnFocusFilter(this)">
          <xsl:attribute name="href">
            javascript: <xsl:if test="$NoAJAX">
              <xsl:call-template name="GenFireServerEvent">
                <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:attribute>
          <xsl:attribute name="onclick">
            <xsl:choose>
              <xsl:when test="not($NoAJAX)">javascript:return OnClickFilter(this,event);</xsl:when>
              <xsl:otherwise>
                javascript: <xsl:call-template name="GenFireServerEvent">
                  <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
                </xsl:call-template>; event.cancelBubble = true; return false;
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="not($NoAJAX)">
              <xsl:attribute name="SortingFields">
                <xsl:value-of select ="$RootFolderParam"/><xsl:value-of select ="$FieldSortParam"/>SortField=<xsl:value-of select="@Name"/>&amp;SortDir=<xsl:value-of select="$linkdir"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="FilterString">
                <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$fieldtype = 'Attachments'">
              <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <span>Del.Date</span>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="$dvt_sortfield = $sortfield">
            <xsl:choose>
              <xsl:when test="$dvt_sortdir = 'ascending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortAsc}" src="{ddwrt:FieldSortImageUrl('Desc')}" />
              </xsl:when>
              <xsl:when test="$dvt_sortdir = 'descending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortDesc}" src="{ddwrt:FieldSortImageUrl('Asc')}" />
              </xsl:when>
            </xsl:choose>
          </xsl:if>
          <img src="/_layouts/images/blank.gif" class="ms-hidden" border="0" width="1" height="1" alt="{$OpenMenuKeyAccessible}"/>
        </a>
        <img src="/_layouts/images/blank.gif" alt="" border="0"/>
        <xsl:choose>
          <xsl:when test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
            <img src="/_layouts/images/filter.gif" border="0" alt="" />
          </xsl:when>
          <xsl:otherwise>
            <img src="/_layouts/images/blank.gif" border="0" alt=""/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="not(@Filterable='FALSE') and ($sortable='FALSE')">
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Del.Date</span>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
          <img src="/_layouts/images/filter.gif" border="0" alt="" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Del.Date</span>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="($fieldtype='BusinessData') and not($XmlDefinition/List/@ExternalDataList='1')">
      <a style="padding-left:2px;padding-right:12px" onmouseover="" onclick="GoToLink(this);return false;"
        href="{$HttpVDir}/_layouts/BusinessDataSynchronizer.aspx?ListId={$List}&amp;ColumnName={$fieldname}">
        <img border="0" src="/_layouts/images/bdupdate.gif" alt="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}" title="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}"/>
      </a>
    </xsl:if>
  </xsl:template>
  <xsl:template name="FieldRef_header.RequisitionDate" ddwrt:dvt_mode="header" match="FieldRef[@Name='RequisitionDate']" mode="header" ddwrt:ghost="hide">
    <th nowrap="nowrap" scope="col" onmouseover="OnChildColumn(this)">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="(@Type='User' or @Type='UserMulti') and ($PresenceEnabled='1')">ms-vh</xsl:when>
          <xsl:otherwise>ms-vh2</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:call-template name="dvt_headerfield.RequisitionDate">
        <xsl:with-param name="fieldname">
          <xsl:value-of select="@Name"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtitle">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="displayname">
          <xsl:value-of select="@DisplayName"/>
        </xsl:with-param>
        <xsl:with-param name="fieldtype">
          <xsl:choose>
            <xsl:when test="@Type='Number' or @Type='Currency'">number</xsl:when>
            <xsl:otherwise>x:string</xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </th>
  </xsl:template>
  <xsl:template name="dvt_headerfield.RequisitionDate" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:variable name="separator" select="' '" />
    <xsl:variable name="connector" select="';'" />
    <xsl:variable name="linkdir">
      <xsl:choose>
        <xsl:when test="$dvt_sortfield = $fieldname and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
        <xsl:otherwise>Asc</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="jsescapeddisplayname">
      <xsl:call-template name="fixQuotes">
        <xsl:with-param name="string" select="$displayname"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$MasterVersion=4 and not($NoAJAX)">
        <div Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
             DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
             class="ms-vh-div">
          <xsl:call-template name="headerfield.RequisitionDate">
            <xsl:with-param name="fieldname" select ="$fieldname" />
            <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
            <xsl:with-param name="displayname" select="$displayname" />
            <xsl:with-param name="fieldtype" select="$fieldtype"/>
          </xsl:call-template>
        </div>
        <xsl:if test="(not($sortable='FALSE') and not(@FieldType='MultiChoice')) or (not(@Filterable='FALSE') and not(@FieldType='Note') and not(@FieldType='URL'))">
          <div class="s4-ctx">
            <span>&#160;</span>
            <a onfocus="OnChildColumn(this.parentNode.parentNode); return false;" onclick="PopMenuFromChevron(event); return false;" href="javascript:;" title="{$open_menu}">
            </a>
            <span>&#160;</span>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="style">padding:0 !important;border:0 !important;</xsl:attribute>
        <div style="width:100%;position:relative;left:0;top:0;margin:0;border:0">
          <xsl:choose>
            <xsl:when test="$NoAJAX">
              <table CtxNum="{$ViewCounter}" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" name="{$fieldname}" DisplayName="{$displayname}" height="100%">
                <xsl:choose>
                  <xsl:when test="$MasterVersion=4">
                    <xsl:attribute name="style">width:100%;height:27px</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:attribute name="style">width:100%</xsl:attribute>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="$sortable='FALSE'">
                  <xsl:attribute name="Sortable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@Filterable='FALSE'">
                  <xsl:attribute name="Filterable">FALSE</xsl:attribute>
                </xsl:if>
                <xsl:if test="@FilterDisableMessage">
                  <xsl:attribute name="FilterDisableMessage">
                    <xsl:value-of select="@FilterDisableMessage" />
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test="not($sortable='FALSE') or not(@Filterable='FALSE')">
                  <xsl:attribute name="onmouseover">
                    <xsl:text disable-output-escaping="yes">OnMouseOverAdHocFilter(this, '</xsl:text>
                    <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
                    <xsl:text disable-output-escaping="yes">' , '', '')</xsl:text>
                  </xsl:attribute>
                  <xsl:attribute name="SortFields">
                    <xsl:value-of select="concat($RootFolderParam,$FieldSortParam,'SortField=',@Name,'&amp;SortDir=',$linkdir)"/>
                  </xsl:attribute>
                  <xsl:attribute name="FieldType">
                    <xsl:value-of select="@FieldType"/>
                  </xsl:attribute>
                  <xsl:attribute name="ResultType">
                    <xsl:value-of select="@ResultType"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:call-template name="headerFieldRow.RequisitionDate">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:when>
            <xsl:otherwise>
              <table style="width:100%;" Sortable="{$sortable}" SortDisable="" FilterDisable="" Filterable="{@Filterable}" FilterDisableMessage="{@FilterDisableMessage}" name="{@Name}" CTXNum="{$ViewCounter}"
                 DisplayName="{@DisplayName}" FieldType="{@FieldType}" ResultType="{@ResultType}" SortFields="{$RootFolderParam}{$FieldSortParam}SortField={@Name}&amp;SortDir={$linkdir}"
                 height="100%" cellspacing="1" cellpadding="0" class="ms-unselectedtitle" onmouseover="OnMouseOverFilter(this)">
                <xsl:call-template name="headerFieldRow.RequisitionDate">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select ="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select ="$fieldtype"/>
                </xsl:call-template>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </div>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="headerFieldRow.RequisitionDate" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <tr>
      <td width="100%" class="ms-vb" nowrap="nowrap">
        <xsl:if test="$MasterVersion=4 and $NoAJAX">
          <xsl:attribute name="style">padding-left:0px;padding-top:5px</xsl:attribute>
        </xsl:if>
        <xsl:call-template name="headerfield.RequisitionDate">
          <xsl:with-param name="fieldname" select ="$fieldname" />
          <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
          <xsl:with-param name="displayname" select="$displayname" />
          <xsl:with-param name="fieldtype" select="$fieldtype"/>
        </xsl:call-template>
      </td>
      <td style="position:absolute;">
        <img src="/_layouts/images/blank.gif" width="13" style="visibility: hidden" alt="" />
      </td>
    </tr>
  </xsl:template>
  <xsl:template name="headerfield.RequisitionDate" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname"  />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:choose>
      <xsl:when test="$Filter='1'">
        <xsl:value-of select ="$Rows/@filter.render" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="(@ImnHeader='TRUE') and ($PresenceEnabled='1')">
            <table cellpadding="0" cellspacing="0" dir="{$XmlDefinition/List/@Direction}">
              <tr>
                <td class="ms-imnImgTD">
                  <img border="0" valign="middle" height="12" width="12" altbase="{$idPresEnabled}" src="/_layouts/images/blank.gif" onload="IMNRegisterHeader(event)" id="imnhdr{position()}"/>
                </td>
                <td nowrap="nowrap" class="ms-vh ms-imnTxtTD">
                  <xsl:call-template name="FieldHeader.RequisitionDate">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </td>
              </tr>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$fieldtype='number'">
                <div align="right" class="ms-numHeader">
                  <xsl:call-template name="FieldHeader.RequisitionDate">
                    <xsl:with-param name="fieldname" select="$fieldname"/>
                    <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                    <xsl:with-param name="displayname" select="$displayname"/>
                    <xsl:with-param name="fieldtype" select="$fieldtype"/>
                  </xsl:call-template>
                </div>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="FieldHeader.RequisitionDate">
                  <xsl:with-param name="fieldname" select="$fieldname"/>
                  <xsl:with-param name="fieldtitle" select="$fieldtitle"/>
                  <xsl:with-param name="displayname" select="$displayname"/>
                  <xsl:with-param name="fieldtype" select="$fieldtype"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldHeader.RequisitionDate" ddwrt:dvt_mode="header" ddwrt:ghost="hide">
    <xsl:param name="fieldname" />
    <xsl:param name="fieldtitle" />
    <xsl:param name="displayname" />
    <xsl:param name="fieldtype" select="'0'"/>
    <xsl:param name="thisNode" select="."/>
    <xsl:variable name="sortable">
      <xsl:choose>
        <xsl:when test="../../@BaseViewID='3' and ../../List/@TemplateType='106'">FALSE</xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="./@Sortable"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="not($sortable='FALSE')">
        <xsl:variable name="sortfield">
          <xsl:choose>
            <xsl:when test="substring($fieldname, string-length($fieldname) - 5) = '(text)'">
              <xsl:value-of select="substring($fieldname, 1, string-length($fieldname) - 6)" />
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$fieldname"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="linkdir">
          <xsl:choose>
            <xsl:when test="$dvt_sortfield = $sortfield and ($dvt_sortdir = 'ascending' or $dvt_sortdir = 'ASC')">Desc</xsl:when>
            <xsl:otherwise>Asc</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="sortText">
          <xsl:choose>
            <xsl:when test="$linkdir='Desc'">&apos; + &apos;descending&apos; + &apos;</xsl:when>
            <xsl:otherwise>&apos; + &apos;ascending&apos; + &apos;</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="jsescapeddisplayname">
          <xsl:call-template name="fixQuotes">
            <xsl:with-param name="string" select="$displayname"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="separator" select="' '" />
        <xsl:variable name="connector" select="';'" />
        <a id="diidSort{$fieldname}" onfocus="OnFocusFilter(this)">
          <xsl:attribute name="href">
            javascript: <xsl:if test="$NoAJAX">
              <xsl:call-template name="GenFireServerEvent">
                <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:attribute>
          <xsl:attribute name="onclick">
            <xsl:choose>
              <xsl:when test="not($NoAJAX)">javascript:return OnClickFilter(this,event);</xsl:when>
              <xsl:otherwise>
                javascript: <xsl:call-template name="GenFireServerEvent">
                  <xsl:with-param name="param" select="concat('dvt_sortfield={',$sortfield,'};dvt_sortdir={',$sortText,'}')"/>
                </xsl:call-template>; event.cancelBubble = true; return false;
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="not($NoAJAX)">
              <xsl:attribute name="SortingFields">
                <xsl:value-of select ="$RootFolderParam"/><xsl:value-of select ="$FieldSortParam"/>SortField=<xsl:value-of select="@Name"/>&amp;SortDir=<xsl:value-of select="$linkdir"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="FilterString">
                <xsl:value-of select="concat($jsescapeddisplayname,$separator,$fieldname, $separator,$fieldtype, $connector, $LCID, $separator, $WebPartClientID)" />
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$fieldtype = 'Attachments'">
              <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <span>Req.Date</span>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="$dvt_sortfield = $sortfield">
            <xsl:choose>
              <xsl:when test="$dvt_sortdir = 'ascending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortAsc}" src="{ddwrt:FieldSortImageUrl('Desc')}" />
              </xsl:when>
              <xsl:when test="$dvt_sortdir = 'descending'">
                <img border="0" alt="{$Rows/@viewedit_onetidSortDesc}" src="{ddwrt:FieldSortImageUrl('Asc')}" />
              </xsl:when>
            </xsl:choose>
          </xsl:if>
          <img src="/_layouts/images/blank.gif" class="ms-hidden" border="0" width="1" height="1" alt="{$OpenMenuKeyAccessible}"/>
        </a>
        <img src="/_layouts/images/blank.gif" alt="" border="0"/>
        <xsl:choose>
          <xsl:when test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
            <img src="/_layouts/images/filter.gif" border="0" alt="" />
          </xsl:when>
          <xsl:otherwise>
            <img src="/_layouts/images/blank.gif" border="0" alt=""/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="not(@Filterable='FALSE') and ($sortable='FALSE')">
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Req.Date</span>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="contains($dvt_filterfields, concat(';', $fieldname, ';' )) or contains($dvt_filterfields, concat(';@', $fieldname, ';' ))">
          <img src="/_layouts/images/filter.gif" border="0" alt="" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$fieldtype = 'Attachments'">
            <xsl:value-of select="$fieldtitle" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <span>Req.Date</span>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="($fieldtype='BusinessData') and not($XmlDefinition/List/@ExternalDataList='1')">
      <a style="padding-left:2px;padding-right:12px" onmouseover="" onclick="GoToLink(this);return false;"
        href="{$HttpVDir}/_layouts/BusinessDataSynchronizer.aspx?ListId={$List}&amp;ColumnName={$fieldname}">
        <img border="0" src="/_layouts/images/bdupdate.gif" alt="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}" title="{$Rows/@resource.wss.BusinessDataField_UpdateImageAlt}"/>
      </a>
    </xsl:if>
  </xsl:template>
  <xsl:template match="View" mode="RenderView" ddwrt:ghost="hide">
    <xsl:variable name="ViewStyleID">
      <xsl:value-of select="ViewStyle/@ID"/>
    </xsl:variable>
    <xsl:variable name="HasExtraColumn" select="$TabularView='1' and $MasterVersion=4 and ($ViewStyleID = '' or $ViewStyleID = '17')"/>
    <xsl:if test="Aggregations[not(@Value='Off')]/FieldRef">
      <tr>
        <xsl:if test="$HasExtraColumn">
          <td/>
        </xsl:if>
        <xsl:if test="$InlineEdit">
          <td width="1%"/>
        </xsl:if >
        <xsl:apply-templates mode="aggregate" select="ViewFields/FieldRef[not(@Explicit='TRUE')]">
          <xsl:with-param name="Rows" select="$AllRows"/>
          <xsl:with-param name="GroupLevel" select="0"/>
        </xsl:apply-templates>
      </tr>
    </xsl:if>
    <xsl:variable name="Fields" select="ViewFields/FieldRef[not(@Explicit='TRUE')]"/>
    <xsl:variable name="Groups" select="Query/GroupBy/FieldRef"/>
    <xsl:variable name="Collapse" select="Query/GroupBy[@Collapse='TRUE']"/>
    <xsl:variable name="GroupCount" select="count($Groups)"/>
    <xsl:for-each select="$AllRows">
      <xsl:variable name="thisNode" select="."/>
      <xsl:if test="$GroupCount &gt; 0">
        <xsl:call-template name="GroupTemplate">
          <xsl:with-param name="Groups" select="$Groups"/>
          <xsl:with-param name="Collapse" select="$Collapse"/>
          <xsl:with-param name="HasExtraColumn" select="$HasExtraColumn"/>
        </xsl:call-template>
      </xsl:if>
      <xsl:if test="not(not($NoAJAX) and not($InlineEdit) and $Collapse and $GroupCount &gt; 0)">
        <xsl:apply-templates mode="Item" select=".">
          <xsl:with-param name="Fields" select="$Fields"/>
          <xsl:with-param name="Collapse" select="$Collapse"/>
          <xsl:with-param name="Position" select="position()"/>
          <xsl:with-param name="Last" select="last()"/>
        </xsl:apply-templates>
      </xsl:if>
    </xsl:for-each>
    <xsl:if test="$InlineEdit and not($IsDocLib) and $ListRight_AddListItems = '1'">
      <xsl:call-template name="rowinsert">
        <xsl:with-param name="Fields" select="$Fields"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>
  <xsl:template mode="Item" match="Row[../../@ViewStyleID='15' or ../../@ViewStyleID='16']" ddwrt:ghost="hide">
    <xsl:param name="Fields" select="."/>
    <xsl:param name="Collapse" select="."/>
    <xsl:param name="Position" select="1"/>
    <xsl:param name="Last" select="1"/>
    <xsl:variable name="NumColumns" select="count($Fields[not(@Type='Note' or preceding-sibling::*[@Type='Note'])])"/>
    <xsl:variable name="thisNode" select="."/>
    <xsl:if test="../../@ViewStyleID='15'">
      <tr>
        <td class="ms-newsletterline" colspan="{$NumColumns}">
          <img src="/_layouts/images/blank.gif" width="100%" height="4" alt="" />
        </td>
      </tr>
    </xsl:if>
    <tr>
      <xsl:if test="../../@ViewStyleID='16' and $Position mod 2 = 1">
        <xsl:attribute name="class">ms-alternating ms-newsletteralt</xsl:attribute>
      </xsl:if>
      <xsl:for-each select="$Fields[position() &lt;= $NumColumns]">
        <xsl:apply-templates select="." mode="printTableCellEcbAllowed">
          <xsl:with-param name="thisNode" select="$thisNode"/>
        </xsl:apply-templates>
      </xsl:for-each>
    </tr>
    <xsl:for-each select="$Fields[position() &gt; $NumColumns]">
      <tr>
        <xsl:if test="$thisNode/../../@ViewStyleID='16' and $Position mod 2 = 1">
          <xsl:attribute name="class">ms-alternating ms-newsletteralt</xsl:attribute>
        </xsl:if>
        <td class = "ms-vb-tall" colspan="{$NumColumns}">
          <xsl:if test="not(@Type='Note')">
            <xsl:value-of select="@DisplayName"/>:
          </xsl:if>
          <xsl:choose>
            <xsl:when test="@Type='User'">
              <xsl:value-of select="$thisNode/@*[name()=concat(current()/@Name, '.span')]" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:apply-templates select="." mode="PrintFieldWithDisplayFormLink">
                <xsl:with-param name="thisNode" select="$thisNode"/>
              </xsl:apply-templates>
            </xsl:otherwise>
          </xsl:choose>
        </td>
      </tr>
    </xsl:for-each>
    <xsl:if test="$NumColumns &lt; count($Fields)">
      <tr>
        <xsl:if test="../../@ViewStyleID='16' and $Position mod 2 = 1">
          <xsl:attribute name="class">ms-alternating ms-newsletteralt</xsl:attribute>
        </xsl:if>
        <td colspan="{$NumColumns}">
          <img src="/_layouts/images/blank.gif" width="100%" height="4" alt="" />
        </td>
      </tr>
    </xsl:if>
  </xsl:template>
  <xsl:template name="FieldRef_printTableCell_EcbAllowed.RequisitionNumber" match="FieldRef[@Name='RequisitionNumber']" mode="printTableCellEcbAllowed" ddwrt:dvt_mode="body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:param name="class" />
    <td>
      <xsl:if test="@ClassInfo='Menu' or @ListItemMenu='TRUE'">
        <xsl:attribute name="height">100%</xsl:attribute>
        <xsl:attribute name="onmouseover">OnChildItem(this)</xsl:attribute>
      </xsl:if>
      <xsl:attribute name="class">
        <xsl:call-template name="getTDClassValue">
          <xsl:with-param name="class" select="$class" />
          <xsl:with-param name="Type" select="@Type"/>
          <xsl:with-param name="ClassInfo" select="@ClassInfo"/>
        </xsl:call-template>
      </xsl:attribute>
      <xsl:apply-templates select="." mode="PrintFieldWithECB">
        <xsl:with-param name="thisNode" select="$thisNode"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>
  <xsl:template name="FieldRef_Text_body.RequisitionNumber" ddwrt:dvt_mode="body" match ="FieldRef[@Name='RequisitionNumber']" mode="Text_body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:choose>
      <xsl:when test="@AutoHyperLink='TRUE'">
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldRef_printTableCell_EcbAllowed.RequisitionItem" match="FieldRef[@Name='RequisitionItem']" mode="printTableCellEcbAllowed" ddwrt:dvt_mode="body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:param name="class" />
    <td>
      <xsl:if test="@ClassInfo='Menu' or @ListItemMenu='TRUE'">
        <xsl:attribute name="height">100%</xsl:attribute>
        <xsl:attribute name="onmouseover">OnChildItem(this)</xsl:attribute>
      </xsl:if>
      <xsl:attribute name="class">
        <xsl:call-template name="getTDClassValue">
          <xsl:with-param name="class" select="$class" />
          <xsl:with-param name="Type" select="@Type"/>
          <xsl:with-param name="ClassInfo" select="@ClassInfo"/>
        </xsl:call-template>
      </xsl:attribute>
      <xsl:apply-templates select="." mode="PrintFieldWithECB">
        <xsl:with-param name="thisNode" select="$thisNode"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>
  <xsl:template name="FieldRef_Text_body.RequisitionItem" ddwrt:dvt_mode="body" match ="FieldRef[@Name='RequisitionItem']" mode="Text_body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:choose>
      <xsl:when test="@AutoHyperLink='TRUE'">
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldRef_printTableCell_EcbAllowed.Material" match="FieldRef[@Name='Material']" mode="printTableCellEcbAllowed" ddwrt:dvt_mode="body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:param name="class" />
    <td>
      <xsl:if test="@ClassInfo='Menu' or @ListItemMenu='TRUE'">
        <xsl:attribute name="height">100%</xsl:attribute>
        <xsl:attribute name="onmouseover">OnChildItem(this)</xsl:attribute>
      </xsl:if>
      <xsl:attribute name="class">
        <xsl:call-template name="getTDClassValue">
          <xsl:with-param name="class" select="$class" />
          <xsl:with-param name="Type" select="@Type"/>
          <xsl:with-param name="ClassInfo" select="@ClassInfo"/>
        </xsl:call-template>
      </xsl:attribute>
      <xsl:apply-templates select="." mode="PrintFieldWithECB">
        <xsl:with-param name="thisNode" select="$thisNode"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>
  <xsl:template name="FieldRef_Text_body.Material" ddwrt:dvt_mode="body" match ="FieldRef[@Name='Material']" mode="Text_body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:choose>
      <xsl:when test="@AutoHyperLink='TRUE'">
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldRef_printTableCell_EcbAllowed.MaterialDescription" match="FieldRef[@Name='MaterialDescription']" mode="printTableCellEcbAllowed" ddwrt:dvt_mode="body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:param name="class" />
    <td>
      <xsl:if test="@ClassInfo='Menu' or @ListItemMenu='TRUE'">
        <xsl:attribute name="height">100%</xsl:attribute>
        <xsl:attribute name="onmouseover">OnChildItem(this)</xsl:attribute>
      </xsl:if>
      <xsl:attribute name="class">
        <xsl:call-template name="getTDClassValue">
          <xsl:with-param name="class" select="$class" />
          <xsl:with-param name="Type" select="@Type"/>
          <xsl:with-param name="ClassInfo" select="@ClassInfo"/>
        </xsl:call-template>
      </xsl:attribute>
      <xsl:apply-templates select="." mode="PrintFieldWithECB">
        <xsl:with-param name="thisNode" select="$thisNode"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>
  <xsl:template name="FieldRef_Text_body.MaterialDescription" ddwrt:dvt_mode="body" match ="FieldRef[@Name='MaterialDescription']" mode="Text_body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:choose>
      <xsl:when test="@AutoHyperLink='TRUE'">
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldRef_printTableCell_EcbAllowed.Quantity" match="FieldRef[@Name='Quantity']" mode="printTableCellEcbAllowed" ddwrt:dvt_mode="body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:param name="class" />
    <td>
      <xsl:if test="@ClassInfo='Menu' or @ListItemMenu='TRUE'">
        <xsl:attribute name="height">100%</xsl:attribute>
        <xsl:attribute name="onmouseover">OnChildItem(this)</xsl:attribute>
      </xsl:if>
      <xsl:attribute name="class">
        <xsl:call-template name="getTDClassValue">
          <xsl:with-param name="class" select="$class" />
          <xsl:with-param name="Type" select="@Type"/>
          <xsl:with-param name="ClassInfo" select="@ClassInfo"/>
        </xsl:call-template>
      </xsl:attribute>
      <xsl:apply-templates select="." mode="PrintFieldWithECB">
        <xsl:with-param name="thisNode" select="$thisNode"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>
  <xsl:template name="FieldRef_Text_body.Quantity" ddwrt:dvt_mode="body" match ="FieldRef[@Name='Quantity']" mode="Text_body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:choose>
      <xsl:when test="@AutoHyperLink='TRUE'">
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldRef_printTableCell_EcbAllowed.Unit" match="FieldRef[@Name='Unit']" mode="printTableCellEcbAllowed" ddwrt:dvt_mode="body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:param name="class" />
    <td>
      <xsl:if test="@ClassInfo='Menu' or @ListItemMenu='TRUE'">
        <xsl:attribute name="height">100%</xsl:attribute>
        <xsl:attribute name="onmouseover">OnChildItem(this)</xsl:attribute>
      </xsl:if>
      <xsl:attribute name="class">
        <xsl:call-template name="getTDClassValue">
          <xsl:with-param name="class" select="$class" />
          <xsl:with-param name="Type" select="@Type"/>
          <xsl:with-param name="ClassInfo" select="@ClassInfo"/>
        </xsl:call-template>
      </xsl:attribute>
      <xsl:apply-templates select="." mode="PrintFieldWithECB">
        <xsl:with-param name="thisNode" select="$thisNode"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>
  <xsl:template name="FieldRef_Text_body.Unit" ddwrt:dvt_mode="body" match ="FieldRef[@Name='Unit']" mode="Text_body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:choose>
      <xsl:when test="@AutoHyperLink='TRUE'">
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldRef_printTableCell_EcbAllowed.Amount" match="FieldRef[@Name='Amount']" mode="printTableCellEcbAllowed" ddwrt:dvt_mode="body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:param name="class" />
    <td>
      <xsl:if test="@ClassInfo='Menu' or @ListItemMenu='TRUE'">
        <xsl:attribute name="height">100%</xsl:attribute>
        <xsl:attribute name="onmouseover">OnChildItem(this)</xsl:attribute>
      </xsl:if>
      <xsl:attribute name="class">
        <xsl:call-template name="getTDClassValue">
          <xsl:with-param name="class" select="$class" />
          <xsl:with-param name="Type" select="@Type"/>
          <xsl:with-param name="ClassInfo" select="@ClassInfo"/>
        </xsl:call-template>
      </xsl:attribute>
      <xsl:apply-templates select="." mode="PrintFieldWithECB">
        <xsl:with-param name="thisNode" select="$thisNode"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>
  <xsl:template name="FieldRef_Text_body.Amount" ddwrt:dvt_mode="body" match ="FieldRef[@Name='Amount']" mode="Text_body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:choose>
      <xsl:when test="@AutoHyperLink='TRUE'">
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldRef_printTableCell_EcbAllowed.Currency" match="FieldRef[@Name='Currency']" mode="printTableCellEcbAllowed" ddwrt:dvt_mode="body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:param name="class" />
    <td>
      <xsl:if test="@ClassInfo='Menu' or @ListItemMenu='TRUE'">
        <xsl:attribute name="height">100%</xsl:attribute>
        <xsl:attribute name="onmouseover">OnChildItem(this)</xsl:attribute>
      </xsl:if>
      <xsl:attribute name="class">
        <xsl:call-template name="getTDClassValue">
          <xsl:with-param name="class" select="$class" />
          <xsl:with-param name="Type" select="@Type"/>
          <xsl:with-param name="ClassInfo" select="@ClassInfo"/>
        </xsl:call-template>
      </xsl:attribute>
      <xsl:apply-templates select="." mode="PrintFieldWithECB">
        <xsl:with-param name="thisNode" select="$thisNode"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>
  <xsl:template name="FieldRef_Text_body.Currency" ddwrt:dvt_mode="body" match ="FieldRef[@Name='Currency']" mode="Text_body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:choose>
      <xsl:when test="@AutoHyperLink='TRUE'">
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldRef_printTableCell_EcbAllowed.DeliveryDate" match="FieldRef[@Name='DeliveryDate']" mode="printTableCellEcbAllowed" ddwrt:dvt_mode="body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:param name="class" />
    <td>
      <xsl:if test="@ClassInfo='Menu' or @ListItemMenu='TRUE'">
        <xsl:attribute name="height">100%</xsl:attribute>
        <xsl:attribute name="onmouseover">OnChildItem(this)</xsl:attribute>
      </xsl:if>
      <xsl:attribute name="class">
        <xsl:call-template name="getTDClassValue">
          <xsl:with-param name="class" select="$class" />
          <xsl:with-param name="Type" select="@Type"/>
          <xsl:with-param name="ClassInfo" select="@ClassInfo"/>
        </xsl:call-template>
      </xsl:attribute>
      <xsl:apply-templates select="." mode="PrintFieldWithECB">
        <xsl:with-param name="thisNode" select="$thisNode"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>
  <xsl:template name="FieldRef_Text_body.DeliveryDate" ddwrt:dvt_mode="body" match ="FieldRef[@Name='DeliveryDate']" mode="Text_body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:choose>
      <xsl:when test="@AutoHyperLink='TRUE'">
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="FieldRef_printTableCell_EcbAllowed.RequisitionDate" match="FieldRef[@Name='RequisitionDate']" mode="printTableCellEcbAllowed" ddwrt:dvt_mode="body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:param name="class" />
    <td>
      <xsl:if test="@ClassInfo='Menu' or @ListItemMenu='TRUE'">
        <xsl:attribute name="height">100%</xsl:attribute>
        <xsl:attribute name="onmouseover">OnChildItem(this)</xsl:attribute>
      </xsl:if>
      <xsl:attribute name="class">
        <xsl:call-template name="getTDClassValue">
          <xsl:with-param name="class" select="$class" />
          <xsl:with-param name="Type" select="@Type"/>
          <xsl:with-param name="ClassInfo" select="@ClassInfo"/>
        </xsl:call-template>
      </xsl:attribute>
      <xsl:apply-templates select="." mode="PrintFieldWithECB">
        <xsl:with-param name="thisNode" select="$thisNode"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>
  <xsl:template name="FieldRef_Text_body.RequisitionDate" ddwrt:dvt_mode="body" match ="FieldRef[@Name='RequisitionDate']" mode="Text_body" ddwrt:ghost="hide">
    <xsl:param name="thisNode" select="."/>
    <xsl:choose>
      <xsl:when test="@AutoHyperLink='TRUE'">
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]" disable-output-escaping ="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$thisNode/@*[name()=current()/@Name]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="View" mode="footer" ddwrt:ghost="hide">
  </xsl:template>
  <xsl:template name="pagingButtons" ddwrt:ghost="hide">
    <xsl:choose>
      <xsl:when test="$XmlDefinition/List/@TemplateType = 106 and $XmlDefinition/@RecurrenceRowset='TRUE'">
        <xsl:if test="$dvt_nextpagedata or $dvt_prevpagedata">
          <xsl:call-template name="CalendarExpandedRecurrenceFooter"/>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:if test="$XmlDefinition/RowLimit[@Paged='TRUE']">
          <xsl:call-template name="CommandFooter">
            <xsl:with-param name="FirstRow" select="$FirstRow" />
            <xsl:with-param name="LastRow" select="$LastRow" />
            <xsl:with-param name="dvt_RowCount" select="$dvt_RowCount" />
          </xsl:call-template>
        </xsl:if>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="CommandFooter" ddwrt:ghost="hide">
    <xsl:param name="FirstRow" select="1"/>
    <xsl:param name="LastRow" select="1"/>
    <xsl:param name="dvt_RowCount" select="1"/>
    <xsl:if test="$FirstRow &gt; 1 or $dvt_nextpagedata">
      <xsl:call-template name="Navigation">
        <xsl:with-param name="FirstRow" select="$FirstRow" />
        <xsl:with-param name="LastRow" select="$LastRow" />
        <xsl:with-param name="dvt_RowCount" select="$dvt_RowCount" />
      </xsl:call-template>
    </xsl:if>
  </xsl:template>
  <xsl:template name="Navigation" ddwrt:ghost="hide">
    <xsl:param name="FirstRow" select="1"/>
    <xsl:param name="LastRow" select="1"/>
    <xsl:param name="dvt_RowCount" select="1"/>
    <xsl:variable name="LastRowValue">
      <xsl:choose>
        <xsl:when test="$EntityName = '' or $LastRow &lt; $RowTotalCount">
          <xsl:value-of select="$LastRow"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$RowTotalCount"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="NextRow">
      <xsl:value-of select="$LastRowValue + 1"/>
    </xsl:variable>
    <table width="100%" border="0" cellpadding="0" cellspacing="0" class="ms-bottompaging">
      <tr>
        <td class="ms-bottompagingline1">
          <img src="/_layouts/images/blank.gif" width="1" height="1" alt=""/>
        </td>
      </tr>
      <tr>
        <td class="ms-bottompagingline2">
          <img src="/_layouts/images/blank.gif" width="1" height="1" alt=""/>
        </td>
      </tr>
      <tr>
        <td class="ms-vb" id="bottomPagingCell{$WPQ}">
          <xsl:if test="not($GroupingRender)">
            <xsl:attribute name="align">center</xsl:attribute>
          </xsl:if>
          <table>
            <tr>
              <xsl:if test="$dvt_firstrow &gt; 1">
                <td>
                  <a>
                    <xsl:choose>
                      <xsl:when test="$dvt_RowCount = 0 and not($NoAJAX)">
                        <xsl:attribute name="onclick">
                          javascript:RefreshPageTo(event, "<xsl:value-of select="$PagePath"/>?<xsl:value-of select="$ShowWebPart"/>\u0026<xsl:value-of select='$FieldSortParam'/><xsl:value-of select='$SortQueryString'/>\u0026View=<xsl:value-of select="$View"/>");javascript:return false;
                        </xsl:attribute>
                        <xsl:attribute name="href">javascript:</xsl:attribute>
                        <img src="/_layouts/{$LCID}/images/prev.gif" border="0" alt="{$Rows/@idRewind}" />
                        <img src="/_layouts/{$LCID}/images/prev.gif" border="0" alt="{$Rows/@idRewind}" />
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:variable name="RealRowLimit">
                          <xsl:choose>
                            <xsl:when test="$XmlDefinition/Query/GroupBy[@Collapse='TRUE']/@GroupLimit">
                              <xsl:value-of select ="$XmlDefinition/Query/GroupBy[@Collapse='TRUE']/@GroupLimit"/>
                            </xsl:when>
                            <xsl:otherwise>
                              <xsl:value-of select = "$XmlDefinition/RowLimit"/>
                            </xsl:otherwise>
                          </xsl:choose>
                        </xsl:variable>
                        <xsl:choose>
                          <xsl:when test="not($NoAJAX)">
                            <xsl:attribute name="onclick">
                              javascript:RefreshPageTo(event, "<xsl:value-of select="$PagePath"/>?<xsl:value-of select="$dvt_prevpagedata"/><xsl:value-of select="$ShowWebPart"/>\u0026PageFirstRow=<xsl:value-of select="$FirstRow - $RealRowLimit"/>\u0026<xsl:value-of select='$FieldSortParam'/><xsl:value-of select='$SortQueryString'/>\u0026View=<xsl:value-of select="$View"/>");javascript:return false;
                            </xsl:attribute>
                            <xsl:attribute name="href">javascript:</xsl:attribute>
                          </xsl:when>
                          <xsl:otherwise>
                            <xsl:attribute name="href">
                              javascript: <xsl:call-template name="GenFireServerEvent">
                                <xsl:with-param name="param" select="concat('dvt_firstrow={',$FirstRow - $XmlDefinition/RowLimit,'};dvt_startposition={',$dvt_prevpagedata,'}')"/>
                              </xsl:call-template>
                            </xsl:attribute>
                          </xsl:otherwise>
                        </xsl:choose>
                        <img src="/_layouts/{$LCID}/images/prev.gif" border="0" alt="{$Rows/@idPrevious}" />
                      </xsl:otherwise>
                    </xsl:choose>
                  </a>
                </td>
              </xsl:if>
              <xsl:if test="$FirstRow &lt;= $LastRowValue">
                <td class="ms-paging">
                  <xsl:value-of select="$FirstRow" /> - <xsl:value-of select="$LastRowValue" />
                </td>
              </xsl:if>
              <xsl:if test="$LastRowValue &lt; $dvt_RowCount or string-length($dvt_nextpagedata)!=0">
                <td>
                  <a>
                    <xsl:choose>
                      <xsl:when test="not($NoAJAX)">
                        <xsl:attribute name="onclick">
                          javascript:RefreshPageTo(event, "<xsl:value-of select="$PagePath"/>?<xsl:value-of select="$dvt_nextpagedata"/><xsl:value-of select="$ShowWebPart"/>\u0026PageFirstRow=<xsl:value-of select="$NextRow"/>\u0026<xsl:value-of select='$FieldSortParam'/><xsl:value-of select='$SortQueryString'/>\u0026View=<xsl:value-of select="$View"/>");javascript:return false;
                        </xsl:attribute>
                        <xsl:attribute name="href">javascript:</xsl:attribute>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:attribute name="href">
                          javascript: <xsl:call-template name="GenFireServerEvent">
                            <xsl:with-param name="param" select="concat('dvt_firstrow={',$NextRow,'};dvt_startposition={',$dvt_nextpagedata,'}')"/>
                          </xsl:call-template>
                        </xsl:attribute>
                      </xsl:otherwise>
                    </xsl:choose>
                    <img src="/_layouts/{$LCID}/images/next.gif" border="0" alt="{$Rows/@tb_nextpage}" />
                  </a>
                </td>
              </xsl:if>
            </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td class="ms-bottompagingline3">
          <img src="/_layouts/images/blank.gif" width="1" height="1" alt=""/>
        </td>
      </tr>
    </table>
    <xsl:if test="not($GroupingRender)">
      <script>
        var topPagingCell = document.getElementById("topPagingCell<xsl:value-of select='$WPQ'/>");
        var bottomPagingCell = document.getElementById("bottomPagingCell<xsl:value-of select='$WPQ'/>");
        if (topPagingCell != null &amp;&amp; bottomPagingCell != null)
        {
        topPagingCell.innerHTML = bottomPagingCell.innerHTML;
        }
      </script>
    </xsl:if>
  </xsl:template>
  <xsl:template name="Freeform" ddwrt:ghost="hide">
    <xsl:param name="AddNewText"/>
    <xsl:param name="ID"/>
    <xsl:variable name="Url">
      <xsl:choose>
        <xsl:when test="List/@TemplateType='119'">
          <xsl:value-of select="$HttpVDir"/>/_layouts/CreateWebPage.aspx?List=<xsl:value-of select="$List"/>&amp;RootFolder=<xsl:value-of select="$XmlDefinition/List/@RootFolder"/>
        </xsl:when>
        <xsl:when test="$IsDocLib">
          <xsl:value-of select="$HttpVDir"/>/_layouts/Upload.aspx?List=<xsl:value-of select="$List"/>&amp;RootFolder=<xsl:value-of select="$XmlDefinition/List/@RootFolder"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$ENCODED_FORM_NEW"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="HeroStyle">
      <xsl:choose>
        <xsl:when test="Toolbar[@Type='Standard']">display:none</xsl:when>
        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:if test="$ListRight_AddListItems = '1' and (not($InlineEdit) or $IsDocLib)">
      <table id="Hero-{$WPQ}" width="100%" cellpadding="0" cellspacing="0" border="0" style="{$HeroStyle}">
        <tr>
          <td colspan="2" class="ms-partline">
            <img src="/_layouts/images/blank.gif" width="1" height="1" alt="" />
          </td>
        </tr>
        <tr>
          <td class="ms-addnew" style="padding-bottom: 3px">
            <span style="height:10px;width:10px;position:relative;display:inline-block;overflow:hidden;" class="s4-clust">
              <img src="/_layouts/images/fgimg.png" alt="" style="left:-0px !important;top:-128px !important;position:absolute;"  />
            </span>
            <xsl:text disable-output-escaping="yes" ddwrt:nbsp-preserve="yes">&amp;nbsp;</xsl:text>
            <xsl:choose>
              <xsl:when test="List/@TemplateType = '115'">
                <a class="ms-addnew" id="{$ID}-{$WPQ}"
                   href="{$Url}"
                   onclick="javascript:NewItem2(event, &quot;{$Url}&quot;);javascript:return false;"
                   target="_self">
                  <xsl:value-of select="$AddNewText" />
                </a>
              </xsl:when>
              <xsl:otherwise>
                <a class="ms-addnew" id="{$ID}"
                   href="{$Url}"
                   onclick="javascript:NewItem2(event, &quot;{$Url}&quot;);javascript:return false;"
                   target="_self">
                  <xsl:value-of select="$AddNewText" />
                </a>
              </xsl:otherwise>
            </xsl:choose>
          </td>
        </tr>
        <tr>
          <td>
            <img src="/_layouts/images/blank.gif" width="1" height="5" alt="" />
          </td>
        </tr>
      </table>
      <xsl:choose>
        <xsl:when test="Toolbar[@Type='Standard']">
          <script type='text/javascript'>
            if (typeof(heroButtonWebPart<xsl:value-of select="$WPQ"/>) != "undefined")
            {
            <xsl:value-of select="concat('  var eleHero = document.getElementById(&quot;Hero-', $WPQ, '&quot;);')"/>
            if (eleHero != null)
            eleHero.style.display = "";
            }
          </script>
        </xsl:when>
        <xsl:otherwise>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:if test="List/@TemplateType = '115'">
        <script type='text/javascript'>
          if (typeof(DefaultNewButtonWebPart<xsl:value-of select="$WPQ"/>) != "undefined")
          {
          <xsl:value-of select="concat('  var eleLink = document.getElementById(&quot;', $ID, '-', $WPQ, '&quot;);')"/>
          if (eleLink != null)
          {
          DefaultNewButtonWebPart<xsl:value-of select="$WPQ"/>(eleLink);
          }
          }
        </script>
      </xsl:if>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>
